*COMDECK HISTORYL410     ***
 DL20010  GIVE ZERO RECORD ORDINAL IN REC. CODE TABLE, FOR
          OMITTED RECORD TYPES. 
          IJB    75/07/25    CBBLDDC
 DL20017  FIXES HANG IN SAMENAME PROCESSING 
          IJB    75/07/25    CBPASS1
L414     ***
 DL20001  REVAMPED THE SYNONYM PROCESSING IN THE ALIAS DIVISION 
          MDS    09/03/75    CBPASS1
 DL20002  DIAGNOSES GROUP ITEMS AND RECORD ENTRIES EXCEEDING 131K 
          MDS    09/03/75    CBSIZE,CWEOR1,CBDIAGM,CBPASS1
 DL20005  TO DETECT EROOR FOR AN IMBEDDED KEY OF AN AK FILE IF THE
          DATA TYPE AND SIZE SPECIFIED IN THE SUB-SCHEMA DIFFERS
          FROM THAT IN THE SCHEMA.
          IJB    7/25/75     CBBLDDC
 DL20006  TO DETECT THE ERROR IF RECORD CODE IS NOT SPECIFIED WHEN- 
          EVER MULTILPLE RECORD TYPES ARE DESCRIBED IN THE SCHEMA.
          IJB    75/10/10    DCSYNX,DCSYNG
 DL20011  INCREASED THE NUMBER OF WORDS IN A SCHEMA READ
          MDS    09/03/75    CBPASS1
 DL20012  TO REMOVE GARBAGE CHARACTERS FROM THE END OF KEY INFORMATION
          MESSAGES. 
          MDS    75/07/17    CBBLDDC
 DL20015  TO COMPARE FOR ASCENDING ORDER SEQUENCE ONLY IF LITERALS
          SPECIFIED IN THE LEVEL-88 ENTRY DESCRIBE A RANGE OF VALUES. 
          IJB    75/07/17    CBPASS1
 DL20018  ISSUES THE CORRECT DIAGNOSTIC IF THE CHARACTER STRING OF A
          PICTURE SPECIFICATION EXCEEDS 30 CHARACTERS.
          MDS    75/07/17    CBPASS1
 DL20019  TO CORRECT MODE PROBLEMS AND PROBLEMS RELATING TO 
          DIAGNOSTICS DURING PROCESSING OF THE PICTURE DESCRIPTIONS 
          IN THE COBOL SUB SCHEMA . 
          IJB    7/30/75     CBPICTUR,CBDIAGM 
 DL20020  REFORMATED THE DIAGNOSTICS
          MDS    09/03/75    CBERROR,CWEOR1,CBDIAGM 
 DL20021  SET THE NO-MAP FLAG FOR NEW GROUP ITEMS 
          MDS    09/03/75    CBCKSS,CBINDEX,CBCLNUP 
 DL20022  CHANGED CHECK FROM THE OCCURS POINTER TO THE DEPENDING ON FLAG
          MDS    09/03/75    CBPASS1,CWEOR1,CBDIAGM 
 DL20024  CORRECTED CONVERSION ROUTINE AND SOURCE LINE POINTER
          MDS    09/03/75    CBPASS1
 DL20025  EXIT TO WRONG ENTRY POINT CORRECTED 
          MDS    09/03/75    CBPASS1
 DL20026  INCREASED AREA LIST BUFFER SIZE TO HOLD 127 AREA NAMES
          MDS    09/03/75    CBPASS1,CBINDEX
 DL20028  ADDED CHECK TO SEE IF TARGET ITEM IS A REDEFINES ITEM 
          MDS    09/03/75    CBPASS1,CWEOR1,CBDIAGM 
 *L420*    *********************************************************************
 DL2*76   UPDATE COPYRIGHT INFORMATION FOR 1976 
          JWP    75/12/04    CNTRL,SYNGEN 
 CP139D2  FIND HHA IN RA+104B RATHER THAN RA+100B, FOR LOADER-54. 
          JWP    09/05/75    CNTRL, LOADOVL 
 DL20003  SUB-SCHEMA LIBRARY ROUTINES AND MODIFICATIONS TO THE
          DIRECTORY ACCESS ROUTINES FOR THE SUB-SCHEMA(COBOL) 
          IJB    10/17/75    CNTRL,CTLSCAN,CBPASS1,CBSSLIB,CWEOR1 
                             LOADOVL,CBIO,CTLIO,CWEOR7
                             CREATEB,CWEOR8 
                             DA$NMSB,DA$OPSB,DA$IO
 DL2A051  THIS MOD IS TO SET MAXIMUM BLOCK LENGTH IN FIT TO A DEFAULT 
          VALUE  OF 5120 CHARACTERS WHEN USER DOES NOT DEFINE BLOCK 
          SIZE
          CHZ    75/09/10    QDLSYN 
 DL2A052  THIS MOD IS TO SET MINIMUM RECORD LENGTH IN AREA FIT
          CHZ    75/09/10    QDLSIZE
 DL20031  SKIP TO THE NEXT SOURCE WORD AFTER ISSUING DIAG 137 
          MDS    75/11/10    CBSYN
 DL20033  CORRECT HANGING PROBLEM WHEN DATA-NAMES ARE THE SAME
          IN A LEVEL-88 ENTRY 
          IJB    10/27/75    CBSYN
 DL20034  TO ISSUE DIAGNOSTIC IF PROCEDURE LIBRARY NOT SPECIFIED IN 
          THE DATA CONTROL SECTION FOR PROCEDURES SPECIFIED IN SCHEMA 
          IJB    10/17/75    DCSYNX 
 DL20035  THIS MOD IS TO SET RECORD MARK FIELD IN FIT 
          CHZ    75/10/24    QDLSYN 
 DL20036  SET VERY LARGE MRL IN SUBSCHEMA DIRECTORY FIT, TO ALLOW 
          LARGE SUBSCHEMA WRITE (UP TO 131000 WORDS). 
          JWP    75/11/07    CBIO 
 DL20040  CHECK FOR KEYWORD -IS- WHEN COMPILING QU IN PICTURE CLAUSE
          CHZ    75/11/04    CTLSCAN
 DL20038  CORRECT LOGIC CHECKING WORK SPACE EXHAUSTED 
          JWP    75/11/05    SYNGEN 
 DL20039  THIS MOD IS TO SET PF CY NUMBER IN LOG FILE FDB 
          CHZ    75/09/01    QDLSYN 
 DL20037  THIS MOD IS TO SET THE  SIGN BIT IN DATA NAME TABLE 
          IF INPUT PICTURE HAS LEADING OR TRAILING - OR 
          HAS LEADING OR TRAILING + 
          CHZ    75/11/04    QDLSYN 
 DL20045  CHANGE NAME OF ALIAS SCRATCH FILE TO ZZZZZCB. 
          ADD ERROR EXIT FOR ZZZZZCB WHICH IGNORES ERROR 143. 
          JWP    75/12/04    CBALIAS
 *L428*    *********************************************************************
 DL20042  CALL FOR CHECK OF FL, TO PREVENT MODE=1.
          JWP    01/22/76    CBPASS1
 DL20043  TO ISSUE DIAGNOSTIC IF EDITING CHARACTERS B OR Z
          ARE SPECIFIED IN PICTURE IN COBOL SUB-SCHEMA. 
          IJB    1/19/76     CBPICTR
 DL20046  THIS MOD IS TO FIX DOMINANT POINTER SO AS TO FIX BWP AND BBP
          CHZ    75/12/15    QDLBLD2 QDLSIZE
 DL20047  PRINT UPDATE IDENTIFIERS IN OUTPUT LISTING OF SCHEMA
          IJB    12/20/75    CTLIO
 DL20048  CORRECTS PROBLEM IN SCHEMA OF EOR BEING IGNORED 
          WHEN DIAGNOSTIC D105 IS ISSUED. 
          IJB    1/13/75     DLSYNTX
 DL20050  THIS MOD IS TO SET CL AND C1 FIELDS IN FIT FOR T TYPE RECORD
          WHEN DEPENDING ON ITEM IS DEFINED AS COMP-1 AND DIAGNOSE
          IF THE ITEM PIC SIZE EXCEEDS 6 CHAR 
          CHZ    76/01/16    QDLSIZE
 DL20051  TO CORRECT THE PROBLEM OF DIAGNOSTIC 165 BEING ISSUED 
          INCORRECTLY IN COBOL SUB-SCHEMA.
          IJB    1/19/76     CBPASS1
 DL20052  TO DETECT SIZE ERRORS IN COBOL SUB-SCHEMA 
          IN THE EVENT OF PREVIOUS ERRORS IN OTHER RECORDS. 
          IJB    4/9/76      CBPASS1
 DL20053  CORRECTS THE PROBLEM OF DIAGNOSTIC 129 BEING ISSUED 
          INAPPROPRIATELY.
          IJB    1/20/76     CBPASS1
 DL20054  CORRECTS PROBLEM OF DIAGNOSTIC 167 BEING ISSUED 
          UNJUSTIFIABLY.
          IJB    1/20/76     CBPASS1
 DL20056  THIS MOD IS TO GIVE AN E TYPE ERROR IF RECORD-NAME IS 
          NOT SPECIFIED 
          CHZ    76/02/15    QDSYNTX, QDDIAG2 
 DL20058  THIS MOD IS TO GIVE AN E TYPE ERROR IF DATA NAME NOT UNIQUE 
          CHZ    76/02/20    QDLSYN, QDDIAG2
 DL20059  THIS MOD IS TO CHECK FIRST 7 CHARS IN AREA OR PF OR LIBRARY 
          NAME DO NOT CONTAIN SPECIAL CHARS 
          CHZ    76/02/25    QDLSYN, QDDIAG2
 DL20060  SET FLAG VALUE TO CAUSE DIAGNOSTIC 302 FOR ITEM NOT IN SCHEMA.
          JWP    03/01/76    CBSCITM
 *L433*    *********************************************************************
 DL20007  TO CORRECTLY PROCESS MULTIPLE VARIABLE DIMENSION GROUPS 
          WITHIN A RECORD. REMOVE ERROR MODE PROBLEM IN SUCH CASES. 
          IJB    6/1/76      DLSCHMA,CWEOR1,DLDIAGM,CWEOR5,DLSYNTX
 DL20041  TO CORRECTLY PROCESS REDEFINES WITHIN REDEFINES IN COBOL
          SUB-SCHEMA. 
          IJB    3/26/76     CBPASS1
 DL20062  THIS MOD IS TO DIAGNOSE IF KEY IS DEFINED AS RECORD-NAME
          OR DEPENDING ON ITEM
          AND TO SET RKP AND RKW FIELDS IN FIT  ONLY IF FO IS SDA 
          CHZ    76/03/19    QDLSIZE
  
 DL20066  TO CORRECT THE PROBLEM OF ENCODE/DECODE PROCEDURES NOT
          BEING INCLUDED IN THE DAT-BASE-PRECEDURE LIST.
          IJB    4/6/76      DLSCHMA
 DL20067  DIAGNOSE ILLEGAL CHARACTERS IN PERMANENT FILE NAME. 
          JWP    76/05/04    QDLSYN, QDDIAG2
  
 DL20068  CORRECT ERROR MODE=1 WHEN BLANK IN PICTURE STRING.
          JWP    76/05/03    QDLPICT
  
 DL20069  CORRECTS THE PROBLEM OF CALL CLAUSE OPTIONS(OPEN,CLOSE,STORE, 
          DELETE,.....) AT THE AREA AND RECORD LEVEL IN THE SCHEMA NOT
          BEING SET PROPERLY. 
          IJB    05/05/76    DLSCHMA
 DL20070  TO CORRECTLY PROCESS ALIAS NAMES IN COBOL SUB-SCHEMA
          IJB    06/08/76    CTLSCAN,CBPASS1,CBDIAG,CWEOR1,CBDIAGM
                             CWEOR5,CBSYN 
 DL20073  ADD FLAG TO SUBSCHEMA DIRECTORY CONTROL WORD INDICATING 
          IF NO ALTERNATE KEYS EXIST IN THE SCHEMA (HENCE NO NEED ALT 
          KEY ENTRY POINTS FROM CRM, AS FAR AS CDCS IS CONCERNED).
          JWP    06/04/76    CBBLDDC,SUBDECLS,CKCKAR
  
 CP150F   CORRECTS THE PROBLEM OF DATA-NAME BUFFER SIZE NOT BEING 
          STORED IN COBOL SUB-SCHEMA CONTROL WORDS. 
          IJB    8/26/76     CBPASS3
 CP150J   ALLOW NON-EMBEDDED PRIMARY KEY TO BE ABSENT FROM SUBSCHEMA. 
          IJB    09/15/76    CBBLDDC
  
 CP150L   CORRECTS THE PROBLEM OF COBOL SUB-SCHEMA TIMING OUT DURING
          THE PROCESSING OF LEVEL-88 DATA ITEMS WHEN IN ERROR 
          IJB    9/17/76     CBPASS1
  
 DL2*77   UPDATE COPYRIGHT INFORMATION FOR 1977 
          JWP    76/10/18    CNTRL,SYNGEN 
  
 DL20064  TO PREVENT COBOL SUB-SCHEMA AND SCHEMA FROM READING PAST
          END-OF-RECORD OR END-OF-INFORMATION IF INPUT FILE IS EMPTY. 
          TO PREVENT READING AFTER END-OF-PARTITION.
          IB     9/01/76     CTLSTD,CTLIO 
  
 DL20071A REMOVE CALCFL CALL CAUSING ERRONEOUS MESSAGE ON SCHEMA ABORT
          RAW    09/17/76    SCHEMIO
  
 DL20078  TO PREVENT QU S-S FROM SETTING SORT KEY INFO IN FIT FOR SEQ 
          SORTED FILES. 
          IB     9/02/76     QDLSIZE
  
 DL20080  CORRECT QU DDL HANDLING OF BLOCK CONTAINS / RECORD CONTAINS.
          JWP    9/13/76     QDLSYN, QDSYNTX
  
 DL20082  CTLSCAN SHOULD NEVER SET NEXT ITEM COLUMN POINTER NEGATIVE. 
          (GAVE GARBAGE IN COLUMN NUMBER FIELD OF RELATION DIAGNOSTICS) 
          IB     07/09/76    CTLSCAN
  
 DL20083  OPEN AND CLOSE PROCEDURES MUST BE SPECIFIED IF SEARCH USED. 
          IB     09/07/76    QDLSYN,QDSYNTX,QDDIAG2 
  
 CP150H   CORRECT REDUNDANT ISSUE OF DIAGNOSTIC 211, SCHEMA.
          IJB    9/14/76     DCSYNX 
  
 CP150N   FIX CB SUBSCHEMA LOOPING TO TIME LIMIT ON RESTRICT OF 
          NON-EXISTENT RECORD NAME. 
          IJB    76/09/29    CBPASS3
  
 CP150O   FIX FORMAT OF SCHEMA DIAGNOSTIC 411.
          JWP    76/09/29    DLRELN, DLDIAGM
  
 CP150P   TO CORRECTLY PROCESS ASCENDING/DESCENDING KEYS IN 
          COBOL SUB-SCHEMA. 
          IJB    10/26/76    CBPASS1
 CP150Q   TO DIAGNOSE  THE PRESENCE OF A VECTOR OF VARIABLE DIMENSION 
          IN A COBOL SUB-SCHEMA WITHOUT A CORRESPONDING ITEM IN THE 
          SCHEMA
          IJB    10/26/76    CBCKSS 
 DL2A094  QU S-S SHOULD DIAGNOSE ZERO OR MORE THAN ONE P KEY FOR AAM AND
          SORTED SEQ FILES. ALSO MINOR CHANGE FOR SORTED AND DUPLICATES.
          IB     9/02/76     QDLSYN,QDSYNTX,QDDIAG2 
  
 DL20086  CORRECT EXHIBIT HANDLING OF ITEMS SUBORD TO GROUP (A FIELD
          WAS TRUNCATED, GIVING GARBAGE OR LOOPING FOR ITEMS WITH 
          ENTRY MORE THAN 32 WORDS FROM THE DOM ITEM ENTRY).
          IJB    10/26/76    EXHIBIT
  
 DL20089  ALLOW DIRECTORY LENGTHS IN EXCESS OF 7777 OCTAL.
          JWP    76/11/11    QDLBLD2
  
 DL20084X FIX COLON CHARS IN SUPPORT OF 63 CHAR SET 
          RAW    76/12/07    CBMAIN,CBPASS1 
  
 DL20090  REMOVE PERCENT GRAPHIC WHICH WOULD PREVENT INSTALLATION ON
          63 CHARACTER SET SYSTEMS. 
          JWP    76/11/18    QDLSYN 
  
 DL20041A TO CORRECT THE PROBLEM OF DIAGNOSTIC 312 BEING ISSUED FOR 
          A GROUP ITEM THAT FOLLOWS NESTED REDEFINES ITEMS IN THE 
          COBOL SUB-SCHEMA. 
          IJB    12/3/76     CBPASS1
 DL20071  ADD SIXTH DIGIT TO CM USED, AS REPORTED IN DAYFILE
          RAW    76/08/30    CTLIO
 DL20071B CORRECT CODE FOR DL20071 TO ALLOW DAYFILE MESSAGE INDICATING
          NUMBER OF DIAGNOSTICS.
          JWP    76/12/16    CTLIO
  
 DL20094  PROVIDE DIAGNOSTIC FOR ILLEGAL PICTURE SPECIFICATION. 
          JWP    76/12/16    QDLPICT
  
 DL20102  CORRECT TREATMENT OF REDEFINES ITEMS IN BLOCK-MAPPING CODE. 
          JWP    77/01/21    CBSTBCK
  
 DL20108
 DL20118  TO CORRECT THE PROBLEM OF THE COBOL SUBSCHEMA TIMING OUT IN 
          RECORD MAPPER APPROACH A CODE.
          IJB    4/27/77     CBSTBCK
 DL20108  IMPLEMENT CODE TO FLAG MAJOR KEYS IN QU DDL.
          AN ITEM IS A MAJOR KEY IF IT IS IMMEDIATELY SUBORDINATE TO
          AN ITEM WHICH IS DECLARED AS A KEY (PRI OR ALT) AND IS
          SHORTER THAN THAT KEY ITEM. 
          ITEM FIELD SBITMALTDUP U(2,18,1) = 1 NOW INDICATES MAJOR KEY
          IF SBITMALTKEY U(2,16,1) = 0. 
          JWP    77/02/10    QDLSIZE
  
 F162DL2A ADD QU/DDL SYNTAX CHANGES FOR CRM 1.5 SUPPORT 
          RAW    77/03/30    QDLSYN QDDIAG2 QDSYNTX 
 DL20004  TO DIAGNOSE THE PRESENCE OF DATA-NAMES THAT ARE NOT 
          UNIQUE WITHIN THE SAME RECORD.
          IJB    1/14/77     CBPASS1
 DL20092  CAUSE QU DDL TO DIAGNOSE RESTRICT ON RECORDS NOT IN SAME ORDER
          AS SPECIFIED IN THE CORRESPONDING RELATION. 
          ADD FIELD IN RESTRICT ENTRY INDICATING RANK OF AREA.
          JWP    76/12/09    QDRSYN, QDDIAG1
  
 DL20100  CORRECT SETTING OF MRL IN AREA FIT IN DATA CONTROL ENTRY. 
          IJB    77/01/05    DCSYNX 
  
 DL20101  TO CORRECTLY PROCESS FIXED M,N TYPE ITEMS IN THE SCHEMA 
          WHEN N HAS A NEGATIVE VALUE.
          IJB    1/12/77     DLSCHMA,DLSYNTX
 DL20103  IMPLEMENT LOGIC TO ALLOW DECIMAL POINT PLACEMENT TO THE 
          RIGHT OF THE DEFAULT POSITION (AS IN PIC 999PPP). 
          JWP    77/01/21    QDLBLD2
  
 DL20104  PREVENT CODE GENERATION FOR E-LEVEL ERRORS, PRIOR TO
          RELATION DIVISION.
          DISCARD THE SUBSCHEMA DIRECTORY FILE IF ERRORS IN RELATION
          DIVISION. 
          ADD DIAGNOSTIC 66.
          JWP    77/01/21    QDLMAIN, QDLDIAG, QDDIAG1, QDRSYN, SUBSCIO 
  
 DL20105  CHANGE SETTING OF KL FOR AK FILES -- SET TO LENGTH IN BITS
          OF PIC FOR THE KEY ITEM (MAX 48 - 48 BY DEFAULT IF NO PIC). 
          JWP    77/01/24    QDLSIZE
  
 DL20106  FIX SYNTAX TO ALLOW MULTIPLE MODES TO BE SPECIFIED IN 
          *ON...CALL* CLAUSE. 
          JWP    77/01/26    QDLSYN 
  
 DL20109  FIX QU DDL TO DISTINGUISH BETWEEN NOS PERMANENT FILE PARAM
          VALUE IN THE -M IS ...- CLAUSE FOR INDEX FILES. 
          JWP    77/01/11    QDSYNTX
  
 DL20110  MAKE ASSIGN PFN MANDATORY FOR LOG CLAUSE OF QU/DDL
          RAW    77/03/30    QDDIAG2 QDSYNTX
  
 DL20114  CHANGE D171 TO READ "UNRECOGNIZABLE/MISPLACED SOURCE STATEMENT
          JGS    77/05/05    QDDIAG2
  
 DL20119  FIX DDL QU SUBSHEMA TO USE THE SAME DEFAULT PIC SIZES AS QU 
          JGS    77/04/28    QDLSYN 
  
 DL20120  CHANGE MESSAGE D107 TO READ "INVALID FILE ORGANIZATION" 
          JGS    77/05/04    QDDIAG2,QDSYNTX
  
 DL20121  CHANGE MESSAGE D101 TO READ "ERROR IN SUB-SCHEMA CLAUSE"
          JGS    77/05/04    QDDIAG2,QDSYNTX
  
 F162DL2C REWRITE OF QDLMAIN FOR BETTER EFFICIENCY
          THIS IS A COMPLETE REPLACEMENT
          JGS    77/07/19    QDLMAIN
  
 DL20116  CODE TO INSURE THAT ALPHA-NUMERIC LITERALS ARE WITHIN QUOTES
          IN THE RELATION DIVISION. 
          JGS    77/05/10    QDRSYN,QDRSYNX 
  
 DL20117  FIX DDL TO COMPILE QU EDITED PICTURE CORRECTLY. 
          JGS    77/06/22    CTLSCAN
  
 DL20123  CODE TO INCLUDE THE LOWER BOUND OF THE OCCURS CLAUSE IN THE 
          SUB-SCHEMA DIRECTORY. 
          JGS    77/05/17    QDLBLD2
  
 DL20126  THIS CODE SETS THE RKW AND RKP FIT FIELDS INTHQ QU SUBSCHEMA
          FOR ALL FO"S, EXCEPT SQ.
          JGS    77/06/20    QDLSIZE
  
 DL20128  THIS CODE FIXES DDL TO PROCESS NON-IMBEDDED KEYS AS PER 
          REFERENCE MANUAL
          JGS    77/06/22    QDSYNTX,QDLSYN,QDDIAG2 
  
 DL20127  CODE TO SET THE EMK FIT FIELD PROPERLY IN QU SUBSCHEMA
          JGS    77/07/01    QDLSYN 
  
 DL20129  CODE TO SET FITMBL TO ZERO IF BLOCK CONTAINS CLAUSE IS
          OMITTED, SO THAT CRM MAY COMPUTE AN OPTIMUM VALUE.
          ALSO CHANGE DIAGNOSTIC 167 TO ISSUE THE RIGHT ASSUMED 
          VALUE OF 5120 INSTEAD OF 512. 
          JGS    77/06/29    QDLSYN,QDDIAG2,QDLSIZE 
  
 DL20132  SET DEFAULT VALUES OF DFC = 0 AND EFC = 3 FOR QU SBUSCHEMA FIT
          JGS    77/07/07    QDLSYN,FITCOM
  
 DS2A140  CODE TO QU/DDL TO CORRECTLY DIAGNOSE ERRORS IN THE
          *RECORD-TYPE IS* AND *BLOCK-TYPE IS* CLAUSES. 
          JGS    77/07/25    QDSYNTX,QDDIAG2,QDDIAG1
  
 DL20133  TO CORRECT THE PROBLEM OF THE COBOL SUBSCHEMA LIBRARY 
          AUDIT ADDING EXTRANEOUS CHARACTERS IN SUBSCHEMA NAMES 
          IJB    8/2/77      CBSSLIB
 DL2A147  FIX THE PROBLEM OF HAVING A WORD OF ZEROES FOLLOWING A
          RESTRICT ENTRY IF THE CHARACTER STRING OF THE RESTRICT
          CLAUSE ENDS AT A WORD BOUNDARY AND ANOTHER RESTRICT 
          CLAUSE FOLLOWS. 
          JGS    77/08/13    QDRSYN 
  
 DL2*78   UPDATE COPYRIGHT INFORMATION FOR 1978 
          IJB    9/1/77      CNTRL ,SYNGEN
 DL20073A TO COPY ALL KEYS FROM SCHEMA INTO COBOL SUB-SCHEMA AND FLAG 
          THE ONES THAT ARE OMITTED FROM THE SUB-SCHEMA IN THE KEY
          ENTRY OF THE RESPECTIVE KEYS. 
          IJB    2/3/77      SBDCDECLS,CBBLDDC
 *L470*    ************************************************************* *L470* 
 D2162F    MAKE ALL QU/DDL DIAGNOSTICS A COMMON DECK                     D2162F 
          ( EQUIVALENT OF F162DL2F )                                     D2162F 
          JGS    77/08/05    COMDDIAG                                    D2162F 
 D2A130   CODE TO QU/DDL TO PERFORM APPROPRIATE VALIDITY CHECKS FOR      D2A130 
          FIT FIELDS                                                     D2A130 
          NOT TO ISSUE DIAGNOSTIC 119 ERROUNEOUSLY                       D2A130 
          DIAGNOSE WRONG USAGE OF A *DEPENDING ON* ITEM.                 D2A130 
          ( EQUIVALENT OF DL2A130 )                                      D2A130 
          JGS    77/08/05    QDLSYN,QDDIAG2,QDSYNTX                      D2A130 
 D2A130A  UNDER CERTAIN CONDITIONS FITCP MAY NOT BE SET                  D2A130A
          ( EQUIVALENT OF DL2A130A )                                     D2A130A
          JGS    77/10/19    QDLSIZE                                     D2A130A
 D2A147A  FIX A PROBLEM IN THE QU/DDL CODE WHERE A WORD OF THE RESTRICT  D2A147A
          ENTRY MAY BE LEFT OUT OF THE DIRECTORY.                        D2A147A
          ( EQUIVALENT OF DL2A147A )                                     D2A147A
          JGS    77/09/27    QDRSYN                                      D2A147A
 D2A160   QU/DDL - OCCURS DEPENDING ON DOES NOT FORCE RT=T.              D2A160 
          ( EQUIVALENT OF DL2A160 )                                      D2A160 
          JGS    77/10/14    QDLSYN                                      D2A160 
 D20134   CODE FOR QU/DDL TO FLAG DOUBLY DEFNED SYMBOLS WITHIN SAME      D20134 
          DOMINANT GROUP                                                 D20134 
          (EQUIVALENT OF DL20134 )                                       D20134 
          JGS    77/09/29    QDLSYN                                      D20134 
 D2A166   TO CORRECT THE PROBLEM OF THE COBOL SUBSCHEMA DIRECTORY        D2A166 
          LOSING THE LAST PRU OF INFORMATION                             D2A166 
          ( EQUIVALENT OF DL2A166 )                                      D2A166 
          IJB    11/08/77    CBSSLIB                                     D2A166 
 DL3A006A TO FIX UP TESTS FROM DDL 3.0 REGRESSION TEST BASE TO ISSUE     DL3A006
          THE RIGHT DIAGNOSTICS                                          DL3A006
          IJB    11/02/77    DLSCHMA,DCSYNX,DLRELN                       DL3A006
 DL3A018  TO CORRECT THE PROBLEM OF SYNGEN COMPILATION ERRORS            DL3A018
          DURING QU BUILD                                                DL3A018
          IJB    11/02/77    SYNGEN                                      DL3A018
 DL3A030  CHANGE MAIN OVERLAY NAMES SO THAT DDL2 AND DDL3 MAY COEXIST    DL3A030
          IN SAME SYSTEM                                                 DL3A030
          JGS    77/10/25    VARIOUS ROUTINES                            DL3A030
DL3A031   PROBLEM - A KEY MAPPING CAPSULE MAY BE GENERATED EVEN IF NO    DL3A031
          KEY MAPPING IS NEEDED.                                         DL3A031
          JGS    77/11/09    MAPKEY                                      DL3A031
                                                                         DL3A031
 TESTFL   MAKE SURE THAT THE DNT STAYS WITHIN FL                         TESTFL 
          JGS    77/12/10    QDLSYN                                      TESTFL 
                                                                         TESTFL 
 D20128A  QU/DDL - GROUP ITEM IS DIAGNOSED AS AN ERROR FOR               D20128A
          NON-IMBEDDED KEYS.                                             D20128A
          JGS    77/10/20    QDLSYN                                      D20128A
          ( EQUIVALENT TO DL20128A)                                      D20128A
 D2A131   TO STORE THE SCHEMA SIZE OF A DATA-NAME(FOR A RESTRICT ENTRY)  D2A131 
          IN THE DATA-NAME SAVE BUFFER - COBOL SUBSCHEMA                 D2A131 
          IJB    12/03/77    CBPASS3                                     D2A131 
          ( EQUIVALENT OF DL2A131 )                                      D2A131 
 D2A152   DDL DOES NOT RECOGNIZE STATEMENT PROPERLY IF STATMENT          D2A152 
          ENDS IN COLUMN 72 AND THERE IS A NON-BLANK IN COL 73.          D2A152 
          IJB    77/10/20    CTLSCAN                                     D2A152 
          ( EQUIVALENT OF DL2A152 )                                      D2A152 
 D2A158   QU/DDL - BLOCK CONTAINS CLAUSE DOES NOT CAUSE THE RB           D2A158 
          FIELD IN THE AREA FIT TO BE SET.                               D2A158 
          JGS    77/10/17    QDLSYN                                      D2A158 
          ( EQUIVALENT TO DL2A158 )                                      D2A158 
 D2162G   TO SET MAXIMUM KEY LENGTH FOR FIRST(ROOT) AREA IN A            D2162G 
          RELATION SEARCH TABLE FOR SPEED-UP OF READ RELATION            D2162G 
          PROCESSING IN CDCS                                             D2162G 
          IJB    12/01/77    CBPASS3,SBRLDBDCL                           D2162G 
          ( EQUIVALENT OF F162DL2G )                                     D2162G 
 D2A164   THIS CODE FIXES THE FOLLOWING PROBLEMS IN QU/DDL               D2A164 
          1) - WRITE THE ENTIRE MURAL OUT TO THE SUB-SCHEMA DIRECTORY    D2A164 
               INSTEAD OF ONLY THE FIRST WORD                            D2A164 
          2) - ALLOW A MAXIMUM MURAL SIZE OF 31D WORDS                   D2A164 
          3) - MAXIMUM ITEM SIZE MUST BE RESTRICTED TO 2047 INSTEAD      D2A164 
               OF 65535 BECAUSE THE SUB-SCHEMA TABLE HAS AN ELEVEN       D2A164 
               BIT FIELD DESCRIBING THE ITEM SIZE.                       D2A164 
          4) - ALPHANUMERIC EDITED ITEMS HAVE AN INTERNAL SIZE OF ZERO,  D2A164 
               CAUSING THE NEXT ITEM TO HAVE THE SAME BWP/BBP.           D2A164 
                                                                         D2A164 
          JGS    77/12/02    QDLSIZE,QDLSYN,QDLBLD2,QDLPICT              D2A164 
          ( EQUIVALENT TO DL2A164 )                                      D2A164 
 D2A149   QU/DDL MAY GENERATE BAD DEFAULT PICTURE SIZES.                 D2A149 
          THIS CODE ALSO INSURES THAT AN ELEMENTARY ITEM HAS THE SAME    D2A149 
          USAGE AS ITS DOMINANT ITEM IF THE LATTER IS A GROUP ITEM.      D2A149 
          JGS    77/08/29    QDLSYN                                      D2A149 
          ( EQUIVALENT TO DL2A149 )                                      D2A149 
 D2A165   WRITE ALL CRM ERROR MESSAGES TO THE ERROR FILE                 D2A165 
          IJB    11/18/77    CTLIO,SUBSCIO,SCHEMIO,CBIO                  D2A165 
          ( EQUIVALENT OF DL2A165 )                                      D2A165 
 D2A167   TO CORRECT DIAGNOSTICS 141 AND 150 IN THE COBOL SUB-SCHEMA     D2A167 
          SO THAT THEY MAY BE INTERPRETED CORRECTLY.                     D2A167 
          IJB    11/18/77    CBDIAGM                                     D2A167 
          ( EQUIVALENT OF DL2A167 )                                      D2A167 
 DL3A026  TO CORRECT THE PROBLEM OF AN INCORRECT RESERVED WORD (REC)     DL3A026
          NOT BEING DIAGNOSED CORRECTLY                                  DL3A026
          IJB    11/18/77    SCSYNCOM                                    DL3A026
 DL2A032  CODE TO FIX MAPKEY LOOP IF REDEFINED ITEM IS PART OF KEY       DL3A032
          AND TO GENERATE CAPSULES FOR MAJOR KEYS                        DL3A032
          IJB    12/01/77    MAPKEY,CODE                                 DL3A032
                                                                         DL3A032
 DL3A033  TO CORRECT THE PROBLEM OF EXHIBIT NOT DECODING RECORD-CODE     DL3A033
          ENTRIES CORRECTLY                                              DL3A033
          IJB    11/18/77    EXHIBIT                                     DL3A033
 DL3A034  TO CORRECT THE SPELLING OF ORGANIZATION IN DIAGNOSTIC 294      DL3A034
          IN THE SCHEMA                                                  DL3A034
          IJB    11/18/77    DLDIAGM                                     DL3A034
 D2A164A  CODE TO FIX A BUG INTRODUCED BY DL2A164 IN PROCESSING          D2A164A
          LOGICAL ITEMS                                                  D2A164A
          JGS    77/12/22    QDLSIZE,QDLBLD2,QDLSYN                      D2A164A
          ( EQUIVALENT TO DL2A164A )                                     D2A164A
 DL3A035  CODE TO FIX THE PROBLEM OF NOT FINDING THE OWNER REALM         DL3A035
          ENTRY IF AN ERROR MAKES IT IMPOSSIBLE TO COMPLETE              DL3A035
          THE ENTRY.                                                     DL3A035
          IJB    77/12/12    CBSYB                                       DL3A035
                                                                         DL3A035
 DL3A036  CODE TO FIX THE FATAL CRM ERRORS ON ZZZZZCB ON A               DL3A036
          COBOL SUB-SCHEMA COMPILATION                                   DL3A036
          IJB    77/12/13    SCHEMIO                                     DL3A036
                                                                         DL3A036
 DL3A040  CODE TO DELETE THE PRINT OUT OF THE CHECKSUMS FROM THE OUTPUT  DL3A040
          JGS    77/12/16    CBSSLIB,DLRELN                              DL3A040
                                                                         DL3A040
DL3A042   CODE TO SUPPORT THE R PARAMETER FOR NOS PERMANENT FILES        DL3A042
          JGS    77/12/29    QDLSYN,QDSYNTX,QDDIAG2                      DL3A042
          ( EQUIVALENT OF DL2A169 )                                      DL3A042
                                                                         DL3A042
 DL3A043  CODE TO FIX THE PROBLEM OF FITKT NOT BEING SET TO THE          DL3A043
          PROPER TYPE                                                    DL3A043
          JGS    77/12/09    QDLSIZE,DCSYNX                              DL3A043
          ( EQUIVALENT OF DL20138 )                                      DL3A043
 DL3A045  QU/DDL DOES NOT ALLOW PF PARAMETERS TO SATRT WITH NUMERIC      DL3A045
          JGS    78/01/12    QDSYNTX,QDLSYN                              DL3A045
          ( EQUIVALENT TO DL20145 )                                      DL3A045
 DL3A050  CODE TO FIX THE PROBLEM OF THE RECORD MAPPER GENERATING        DL3A050
          BAD LOOP CODE                                                  DL3A050
          JGS    78/01/27    GLC                                         DL3A050
                                                                         DL3A050
 DL3A051  SET MNR IN FIT TO THE CORRECT DEFAULT VALUE IF IT IS NOT       DL3A051
          SPECIFIED ON THE FILE CARD FOR AN AREA.                        DL3A051
          IJB    2/2/78    DCSYNX,DLDIAGM,QDLSIZE,QDDIAG1                DL3A051
 DL3A051A CODE TO FIX A BUG IN DL3A051                                   DL3A051
          MNR IS NOT SET PROPERLY                                        DL3A051
          JGS    78/02/21          QDLSIZE                               DL3A051
                                                                         DL3A051
 DL3A052  QU/DDL DOES NOT ALWAYS SET MAJOR KEY FLAG                      DL3A052
          JGS    78/02/08    QDLSIZE                                     DL3A052
          (EQUIVALENT TO DL2A183)                                        DL3A052
                                                                         DL3A052
 *L477*    **************************************************** 
 DL3A041  CODE TO DDL TO CHECK ES BEFORE FP IN THE INPUT FILE FIT 
          JGS    78/01/05    CTLIO
          ( EQUIVALNET OF DL2A173 ) 
  
 DL3A044  QU/DDL MAY GENERATE BAD HASH TABLES 
          JGS    77/12/21    QDLBLD2
          ( EQUIVALENT TO DL2A168 ) 
  
 DL3A046  TO PROCESS THE CHECK IS PICTURE CLAUSE CORRECTLY IN THE 
          COBOL SUBSCHEMA 
          IJB    2/16/78     DLSCHMA,CBCKSCM,CBCKITM,CBCKEL,CBERROR 
          ( EQUIVALENT OF DL2A177 ) 
 DL3A046A TO CORRECT THE RESPONSE TO PSR DL3A046 IN THE EVENT WHEN
          SUBSCHEMA ITEM SIZES ARE GREATER THAN THE CORRESPONDING 
          SCHEMA ITEM SIZES 
          ( EQUIVALENT OF DL2A177A )
          IJB    3/15/78     CBCKITM,CBERROR,CBCKEL 
 DL3A047  CODE TO FIX COMPILE ERROR IN ARG WHEN DEBUG IS DEFINED
          REF    78/1/24     ARG
 DL3A053   CODE TO THE DARS TO OPEN THE SUBSCHEMA FOR INPUT ONLY
          JGS    78/02/06    DA$IO,DA$OPSB
  
 D2A152A  CORRECT THE ORIGINAL CODE SO THAT DIAGNOSTIC 99 IS NOT
          ISSUED IN ERROR 
          JGS    78/03/23    CTLSCAN
  
 D2A164B  CODE TO FIX THE PROBLEM OF THE RECORD SIZE BEING
          TRUNCATED TO 12 BITS
          JGS    78/03/21          QDLBLD2,QDLSIZE,QDDIAG2
  
 DL3A039  REARRANGE COMDECK CBSYNCOM SO THAT COBOL RESERVED WORDS ARE 
          NOT TREATED AS DDL NAMES. 
          JGS    78/03/23    CBSYNCOM 
  
 DL3A054  QU/DDL DOES NOT ALLOW NOS PF OPTIONS M = A AND M = RA 
          JGS    78/02/17          QDLSYN,QDSYNTX 
  
 DL3A055  CODE TO QU/DDL TO SET MAJOR KEY FLAG IF 
          MAJOR KEY HAS SAME SIZE AS KEY. 
          JGS    78/03/08          QDLSIZE
          (EQUIVALENT TO DL2A185) 
  
 DL3A056  CODE TO QU/DDL SO THAT FL-1 IS NOT USED 
          JGS    78/03/09          QDLSYN 
          ( EQUIVALENT TO DL2A180)
  
 DL3A058  QU/DDL CODE TO FIX THE PROBLEM OF ON OPEN ...CLOSE CALL XALL
          WORKING LIKE ON CLOSE CALL XALL.
          JGS    78/03/14          QDLSYN,QDSYNTX,QDLBLD2,QDDIAG1 
          (EQUIVALENT TO DL2A161) 
  
DL3A059   CODE TO FIX THE UNEXPECTED DIAGNOSITCS IF ERROR ON
          AREA-NAME CLAUSE
          SNT    78/06/16          QDLSYN 
  
 DL3A062  TO CORRECT THE PROBLEM OF NON-IMBEDDED KEYS NOT BEING 
          INCLUDED IN THE KEY ENTRIES IN THE SCHEMA.
          IJB    6/3/78      DCSYNX 
 DL3A064  TO CORRECT THE PROBLEM IN DIRECTORY ACCESS ROUTINE DE$RCSB, 
          WHERE STATUS OF RECORD ACCESSESS ARE INTERMITTENTLY 
          RETURNED AS "NOT FOUND".
          IJB    6/14/78     DA$NMSB
 DL3A065  TO CORRECT THE PROBLEM OF A REDEFINES ITEM LOOPING TO TIME
          LIMIT IF THERE ARE NO SUBORDINATE ITEMS - COBOL SS. 
          IJB    6/15/78     CBPASS1,CBSIZE 
          ( EQUIVALENT OF DL20156 ) 
 DL3A070  TO CORRECT THE PROBLEM OF THE ENDING COMMENT DELIMETER
          IN THE SCHEMA NOT BEING DETECTED IF BROKEN UP ACROSS LINES. 
          IJB    7/10/78     CTLSCAN
                 ( EQUIVALENT OF DL20150 )
 F2650DL3 IMPLEMENTATION OF COMPLEX DATA TYPE IN THE SCHEMA FOR SUPPORT 
          OF THE FORTRAN DATA BASE FACILITY(FDBF) DATA TYPES. 
          IJB    7/23/78     DLSCHMA,DCSYNX,DLDIAGM,DLSYNTX,CBCKCNV 
 F2650DL3A SUPPORT CODE IN DDL3 FOR FDBF
           IJB     07/25/78      DDL3 
 DL3A066  CODE TO FIX THE BAD MAPPING CAPSULE GENERATED FOR 
          WRITING VECTORS.
          JGS    78/06/27          GLC,MAPWR,COMDLOOP 
  
 DL3A068  TO CORRECT THE PROBLEM OF DDL3 NOT ENFORCING THE
          RULE THAT THE ACCESS-CONTROL LITERAL MUST BE NON-NUMERIC. 
          PAM    7/20/78     DLSYNTX,CTLSTD 
 DL3A069  CODE TO HAVE QDLSIZE TO ABORT RUN ON E-TYPE ERROR 
          SNT    78/07/25          QDLSIZE
  
 DL3A071  TO CORRECT THE PROBLEM OF DIAGNOSTIC 138 BEING ERRONEOUSLY
          ISSUED WHEN THERE ARE OTHER COMPILATION ERRORS DURING A SCHEMA
          COMPILATION.
          IJB    7/21/78     DLSCHMA
          ( DUPLICATE OF DL2A195 )
 DL3A072  TO CORRECT THE PROBLEM OF THE DECIMAL PT OF SCHEMA DEFINED
          ITEM NOT BEING DECODED CORRECTLY BY THE EXHIBIT UTILITY.
          IJB    7/27/78     EXHIBIT
 DL3A076  TO CORRECT THE PROBLEM IN CONVERSION ROUTINE DC$CONV
          WHERE CONVERSION FROM DOUBLE PRECISION TO INTEGER IS NOT
          DONE CORRECTLY. 
          IJB    8/28/78     DCCONV 
 DL3A077  CHANGE THE PRECEDENCE TABLE IN QDLPICT SO THAT QU/DDL 
          ACCEPTS SLASHES AND COMMAS AS EDITING CHARACTERS FOR
          NON NUMERIC ITEMS.
          JGS    78/08/24    QDLPICT
  
 F2632DL3 CONSTRAINT FEATURE CODE FOR DDL3                               BK 
          JGS    78/08/0     SCCWDECLS,SCAHDDCLS,SCSYNCOM,SCCSHDDCL      BK 
                             SCCSVRDCL,SCDCKYDCL,DL10,DCSYNX,EXHIBIT     BK 
                             EXDIAG,CTLIO,LOADOVL,DLDIAGM,DCSYNG,CREATEB BK 
                             EXSYNTX,CSSYNX,CSSYNTX                      BK 
                                                                         BK 
 F2631DL3A MODIFICATIONS TO THE DDL 3.0 CHECKSUM CODE.
          THE *A* RESPONSE REPRESENTS THE MODS TO THE SCHEMA ONLY.
          IJB    9/6/78      DLSCHMA,DCSYNX,DLRELN,CKSUM
 F2631DL3B MODIFICATIONS TO THE DDL 3.0 CHECKSUM CODE.
           THE *B* RESPONSE REPRESENTS MODS TO COBOL SUBSCHEMA ONLY.
          IJB    9/6/78      CBSSLIB
 F2827DL3 CODE TO THE RECORD MAPPER TO RETURN THE SUBSCHEMA ITEM
          ORDINAL TO CDCS ON RECORD MAPPING ERRORS. 
          JGS    78/28/08    DDLCG,GEN,MAPWR
  
F2827DL3F THIS CODE PERFORMS THE GARBAGE COLLECTION ON COBOL SUBSCHEMA
          LIBRARY FILES.  IT IS TRIGGERED BY THE NL=LFN PARAMETER ON THE
          DDL CONTROL CARD.  LFN IS THE NAME OF THE NEW SUBSCHEMA 
          LIBRARY GENERATED AFTER THE GARBAGE COLLECTION HAS BEEN DONE. 
          PAM    09/18/78    ARG,CNTRL,CBIO,CBSSLIB 
 F2827D3AA THE *A* RESPONSE REPRESENTS CODE ADDED TO THE (0,0) OVERLAY
          FOR IMPLEMENTATION OF THE MULTIPLE COMPILE CAPABILITY IN
          THE COBOL SUBSCHEMA PROCESSOR.
          IJB    9/23/78     CNTRL,CTLIO
 F2827D3AB THE *B* RESPONSE REPRESENTS CODE ADDED TO THE (4,0),(4,1), 
          (4,3) OVERLAYS FOR IMPLEMENTATION OF THE MULTIPLE COMPILE 
          CAPABILITY IN THE COBOL SUBSCHEMA PROCESSOR.
          IJB    9/23/78     CBMAIN,CBPASS1,CBSYN,CBPASS3,CBRSYN
                             CBDIAG,CBDIAGM 
 F2827D3AC THE *C* RESPONSE REPRESENTS CODE ADDED TO THE (7,0)
          OVERLAY FOR IMPLEMENTATION OF THE MULTIPLE COMPILE
          CAPABILITY IN THE COBOL SUBSCHEMA PROCESSOR.
          IJB    9/23/78     CBSSLIB
 F2827D3AD THE *D* RESPONSE REPRESENTS ENHANCEMENTS TO THE MULTIPLE 
          COMPILE FEATURE.
          IJB    9/28/78     CBSSLIB,CTLIO
 F2827D3DA THE *A* RESPONSE REPRESENTS THE IMPLEMENTATION IN THE SCHEMA 
          FOR THE SUPPORT OF EXTENDED DA AND AK FILE ORGANIZATIONS. 
          IJB    9/30/78     DCSYNX,DLDIAGM 
 F2827D3DB THE *B* RESPONSE REPRESENTS THE CODE IN THE RECORD MAPPER, 
          OVERLAY (6,N),FOR THE SUPPORT OF EXTENDED DA AND AK FILE
          ORGANIZATIONS.
          IJB    9/29/78     MAPKEY 
 F2827DL3E
          NEW FEATURE CODE ON ORGANIZATION STATEMENT.  FOR THE
          "ORGANIZATION IS DIRECT/ACTUAL", WE CAN HAVE AN OPTION
          IN CHOOSING EITHER OLD/NEW - OLD IS DEFAULT.
          SNT    78/09/29          QDLSIZE,QDSYNTX
  
 F2827D3BA THE *A* RESPONSE REPRESENTS CODE TO THE SCHEMA AND EXHIBIT 
          UTILITY FOR THE COMPRESSION/DECOMPRESSION FEATURE.
          PAM    10/19/78    DCSYNX,EXHIBIT,DLDIAGM,DCSYNG
                             FITCOM,SCDCHDDCL,SCDCKYDCL 
 F2827D3BB THE *B* RESPONSE REPRESENTS CODE TO THE COBOL SUBSCHEMA
          FOR THE COMPRESSION/DECOMPRESSION FEATURE.
          PAM    10/19/78    SBDCHDDCL,SBDCKYDCL,CBBLDDC
 F2827D3AE CORRECTS ERRORS UNCOVERED IN THE MULTIPLE COMPILE FEATURE. 
          IJB    10/19/78    CBPASS1,CBERROR,CTLIO
 F2827D3BC TO GENERATE NEW COMMON DECKS IN THE SCHEMA AND SUBSCHEMA 
          DATA CONTROL ENTRIES FOR THE COMPRESSION/DECOMPRESSION
          FEATURE.
          DATA CONTROL ENTRIES FOR THE COMPRESSION/DECOMPRESSION FEATURE
          PAM    10/21/78    SCDCCDDCL,SBDCCDDCL
 F2827D3EA
 ADDITIONAL CODE FOR F2827DL3E TO SET RKP = KP FOR ACTUAL KEY - NEW ONLY
          SNT    78/10/26          QDLSIZE
 F2827D3DC ADDITIONAL CODE FOR THE SUPPORT OF DA/AK TO SET RKP=KP.
          IJB    10/30/78    DCSYNX 
 F2827D3BD  CORRECTS ERRORS UNCOVERED IN THE COMPRESSION/DECOMPRESSION
          FEATURE 
          PAM    11/3/78     DCSYNX 
 DL3A078  TO CORRECT THE PROBLEM OF ACCESS-CONTROL LITERALS NOT BEING 
          STORED CORRECTLY IN THE SCHEMA DIRECTORY. 
          IJB    9/28/78     DLSCHMA
 DL3A012  TO CORRECT THE PROBLEM IN GENERATING THE RIGHT INFORMATION
          IN THE COBOL SUBSCHEMA DIRECTORY FOR INDEXED BY OPTION. 
          IJB    10/20/78    CBPASS1
 DL30001  TO CORRECT THE PROBLEM OF THE MNR VALUES NOT BEING
          PROCESSED CORRECTLY IN THE SCHEMA.
          IJB    10/03/78    DCSYNX,DLDIAGM 
 DL3A008  TO CORRECT THE PROBLEM OF TEST DC129E OF THE I+E TEST BASE
          PRODUCING TOO MANY DIAGNOSTICS. 
          IJB    10/16/78    DLSYNTX
 DL3A048  TO CORRECT THE PROBLEM OF SYNGEN NOT RECORDING THE FL USED
          PROPERLY
          PAM    11/2/78     SYNGEN 
 DL3A060  TO CORRECT THE PROBLEM OF SYNGEN MODING OUT IF THE FIELD
          LENGTH IS NOT EXPLICITLY SPECIFIED VIA A *RFL*. 
          IJB    11/9/78     SYNGEN 
 DL3A073  ENSURE THAT NO RECORD MAPPING IS REQUIRED FOR SUBSCHEMA 
          ITEMS OF DATA CLASS \ 10 WITH THE SIGN SPECIFIER IN THE 
          PICTURE DEFINITION. 
          IJB    11/1/78     CBCKEL 
 DL3A071  TO CORRECT THE PROBLEM OF DDL3 NOT RECOGNIZING INCORRECT
          ORDER OF CONCATENATED KEYS IN THE SUBSCHEMA.
          PAM    10/16/78    CBERROR,CBBLDDC
 DL3A075  TO CORRECT THE PROBLEM OF THE COBOL SUBSCHEMA MODING OUT
          DURING RECORD MAPPING WHEN GROUP ITEMS NOT DEFINED IN THE 
          SCHEMA HAVE THE SAME NAME.
          IJB    10/12/78    CBCKREC
 DL3A080  TO CORRECT THE PROBLEM OF DDL 3 NOT CHECKING THE XN FIELD IN
          THE FIT FOR ALTERNATE KEYS. 
          PAM    10/24/78    DCSYNX,DLDIAGM,FITCOM
 DL3A081  TO CORRECT THE SPELLING OF #EMBEDDED# IN THE DIAGNOSTICS OF 
          DDL 3.
          PAM    10/24/78    DLDIAGM,CBERROR
 DL3A084  TO CORRECT THE PROBLEM OF RECORD ORDINALS NOT BEING STORED
          IN THE RECORD CODE ENTRY IN THE COBOL SUBSCHEMA.
          IJB    10/27/78    CBBLDDC
 DL3A085  INTRODUCES AN ERROR LIMIT IN SYNGEN,AND IF EXCEEDED ABORTS
          THE COMPILATION.
          IJB    11/10/78    SYNGEN 
 DL3A086  CODE TO ISSUE A DIAGNOSTIC MESSAGE FOR ELEMENTARY ITEM
          WHICH HAS NO PICTURE SPECIFICATION; DIAG-NO = C149. 
          THIS CODE ALSO REFLECTS THE CHANGE ON DIAGNOSTIC MESSAGES 
          149 AND 173 TO BE ISSUED WITH THE CORRECT LINE NUMBER.
          SNT   78/11/13          QDLSYN,COMDDIAG,QDDIAG2 
          (EQUIVALENT OF DL20164) 
  
 DL3A087  CODE TO FIX THE INCORRECTLY COMPUTED BWP,BCP FOR SOME ITEMS 
          FOLLOWING A GROUP ITEM. 
          SNT    78/11/16                      QDLSIZE
          (EQUIVALENT OF DL20141) 
  
 F2827D3DD THE *D* RESPONSE REPRESENTS CODE IN THE RECORD MAPPER, 
          OVERLAY (6,N), FOR THE SUPPORT OF EXTENDED DA/AK FO.
          IJB    11/8/78     MAPKEY 
 F2827D3FA TO CORRECT THE PROBLEM OF DDL3 NOT DIAGNOSING AN 
          UNEQUIVALENCED NL PARAMETER IN THE DDL CONTROL CARD.
          PAM    11/30/78          ARG
 F2827DL3G NEW FEATURE - ADD DATA BASE PROCEDURE (DBP) EXIT 
           "ON RETRIEVAL" TO THE EXISTING 7 CALL OPTIONS. 
           FOR EXAMPLE: ON RETRIEVAL CALL DBP-NAME. 
           SNT    78/12/01          QDLSYN,QDSYNTX,COMDDIAG,QDDIAG2 
  
 F2827DL3H INTRODUCE PROC AND END STATEMENTS INTO SYNGEN DECKS. ALSO, 
          REMOVE DEFAULT PROC NAME FROM CREATEB FOR EXHIBIT.
          IJB    11/29/78    SYNGEN DECKS,CREATEB 
 F2632DL3A  CHANGE CONSTRAINT SYNTAX TO *DEPENDS ON* INSTEAD OF 
           *IS EQUAL TO*
           JGS    78/11/29    SCSYNCOM,CSSYNTX,DLDIAGM
  
 F2827D3CA CORRECTION TO THE RECORD MAPPING MODIFICATIONS.              000120
           * DB$MSSO * MUST BE IN ALPHABETICAL ORDER IN THE EXTERNAL    000130
           DATA LIST.                                                   000140
          IJB    10/20/78    DCMREL                                     000150
                                                                        000151
 DL3A067  CODE TO ISSUE AN ERROR DIAGNOSTIC FOR UNEQUAL RECORD SIZE 
          IN THE SAME AREA, THE LARGEST ONE IS USED FOR MRL,
          DIAG-NO = C146
          SNT    78/09/11          QDDIAG2,QDLSIZE,COMDDIAG 
  
 DL3A082  TO CORRECT THE PROBLEM OF DDL3 NOT HANDLING THE KT FIELD ON 
          THE FILE CARD CORRECTLY.
          PAM    10/26/78    DCSYNX 
 F2632DL3B CHANGES CERTAIN ITEM DECLARATIONS IN COMDECK SCCSVRDCL 
          FROM TYPE *U* TO TYPE *I*.
          IJB    12/14/78    SCCSVRDCL
 F2827D3FB TO CORRECT THE PROBLEM OF THE INPUT FILE BEING ADVANCED TO 
          THE NEXT *EOR* DURING GARBAGE COLLECT.
          IJB    12/15/78     CTLIO 
 DL3A089  FOR AN ITEM WHICH HAS AN USAGE CLAUSE WITHOUT SPECIFYING
          THE PICTURE SIZE, A DEFAULT PICTURE VALUE WILL BE SET.
          THE USAGES ARE:  COMP/COMPUTATIONAL, COMP-1, COMP-2, COMPLEX, 
          DISPLAY, DOUBLE, INTEGER AND LOGICAL. 
          SNT    78/12/19          QDLSYN,QDLBLD2 
  
 F31IB0INCLUDE THE FIT LENGTH IN COMPUTING THE MINIMUM SUB-ENTRY
          LENGTH. 
          IJB    12/21/78    DLSCHMA
 DL3*79   UPDATE COPYRIGHT INFORMATION FOR 1979.
          IJB    12/28/78    CNTRL,SYNGEN 
 F31JS01  FIX BUG INTRODUCED BY COMPRESSION/DECOMPRESSION AND 
          UNCOVERED BY AK TESTING. FIT WORD HAS BEEN MOVED FROM 
          WORD 4 TO WORD 6 OF THE DATA CONTROL HEADER.
          JGS    79/01/03    SBDCHDDCL
  
 F31IB02  CORRECTS THE PROBLEM OF INCORRECT CHECKSUMS BEING GENERATED 
          FOR SCHEMA AREAS. 
          IJB    01/10/78    DCSYNX,DLSCHMA 
 F31IB03  MOVE FIELD * SBCWSBHDRPTR * IN COMDECK SBCWDECLS TO 
          ACCOMODATE THE QU SUBSCHEMA LIBRARY FEATURE REQUIREMENTS. 
          IJB    1/18/79     SBCWDECLS
 DL3A088  FITCP IS NOT SET CORRECTLY IF DEPENDING ON ITEM IS COMP-1.
          SNT    79/01/18          QDLSIZE,QDLSYN 
          (EQUIVALENT OF DL2A204) 
  
 DL3A090  TO CORRECT THE PROBLEM OF DDL3 NOT CHECKING IF THE
          CONCATENATED KEY IN THE SUBSCHEMA IS A NON-REPEATING GROUP
          ITEM. 
          PAM    1/3/79      CBBLDDC
 DL30003  MAPKEY GETS MODE 1 PROCESSING MAJOR KEY IF PART OF A
          REDEFINED KEY. (SCIP = 0) 
          JGS    78/12/19    MAPKEY 
  
 F31JS02  FIX DECLARATION IN SBCWDECLS FOR SUB-SCHEMA DATE AND TIME 
          JGS    79/01/26    SBCWDECLS
  
 F31PM01  THIS IDENT IS FOR CHANGING THE 6,X AND 7,0 OVERLAYS INTO
          COMMON DECKS TO BE SHARED BY DDL AND FDBF.  ALL OF THE SOURCE 
          CODE IN THE ORIGINAL DECKS IS MADE INTO COMMON DECKS EXCEPT 
          FOR THE PRGM OR PROC HEADER.  THE ORIGINAL DECKS ARE PURGED 
          AND THEN RECREATED WITH JUST THE HEADER AND A CALL TO THE 
          RESPECTIVE COMDECK.  IN ADDITION, SEVEN ENTRY POINTS ARE
          ADDED TO THE 7,0 OVERLAY (CBSSLIB) AND ARE DEFINED AS WEAK
          EXTERNALS SINCE THEY ARE USED ONLY BY FDBF. 
          PAM    2/27/79     ALL DECKS IN (6,0),(6,1),(6,2), AND (7,0)
                             OVERLAYS 
 F31PM02  TO CALCULATE THE LWA OF 7,0 OVERLAY FROM THE FOL DIRECTORY
          PAM    2/22/79     DDLCG,CNTRL,CREATEB,LOADOVL
 F31PM03  TO CHANGE EXTERNAL REFERENCES SO THEY MATCH THE ENTRY POINTS
          IN COMPASS COMMON COMMON DECKS
          PAM    3/2/79      CTLIO,XCDD,XCOD,ARG,OCTAL
 F31PM03A CHANGES "DDLF" TO "DDL" IN SUBSCHEMA LIBRARY DIAGNOSTICS
          PAM    3/9/79      CBSSLIB
DL3A092   FIX SEVERAL MINOR BUGS IN CONSTRAINT SYNTAX PROCESSING
          JGS    79/03/01    CSSYNTX,CSSYNX,DLDIAGM 
  
 DL3A094  VECTOR MAPPING DESTROYS CMM POINTER CAUSING MODE 1. 
          SCHEMA DEFINES A VECTOR WITHIN A VARIABLE DIMENSION 
          REPEATING GROUP. SUB-SCHEMA OMITS VECTOR. MAPWR NULL FILLS
          TOO FAR, WIPING OUT A CMM POINTER.
          JGS    79/03/20    COMMAPWR,COMGLC
  
 F31IB04  INCORPORATES SYMPL TEXTS INTO DDL.
          IJB    3/2/79      DLSCHMA,DLSIZE,DCSYNX,DLRELN,CSSYNX
                             DLHASH 
                             CBPASS1,CBSIZE,CBINDEX,RELSTAT 
                             ALL PASS 2 SYMPL DECKS,CBPASS3,CBSSLIB 
 F2829D3A ADDS A LIST OF DATA-BASE-PROCEDURES TO THE END OF SCHEMA
          COMPILATION LISTING.
          PAM    3/21/79     DLRELN,CREATEB 
 F2829D3B QU/CRM SUB-SCHEMA LIBRARY FOR DDL3                            014830
          SNT    70/04/23          CNTRL,QDLMAIN,QDLSYN,QDLBLD2,QDRSYN  014840
                                   QDSSLIB,LOADOVL,SUBSCIO,CREATEB      014850
                                                                        014860
 F2540D3CD MODS TO COMMON DECKS TO SUPPORT QU/CDCS SUB-SCHEMA 
          JGS    79/14/18     SBCWDECLS,CBAHDDCLS,SBIHDDCLS 
  
 F31IB06  MODIFY DARS TO CLOSE THE SUBSCHEMA FILE IF ALREADY OPEN,
          BEFORE ISSUING ANOTHER CRM OPEN - BAMLIB DOES NOT ALLOW A 
          STORE IN THE OC FIELD IN THE FIT. 
          IJB    5/8/79      DA$OPSC,DA$IO
 F2540D3  MODS TO DDL3 TO SUPPORT QU/CDCS SUBSCHEMA 
          JGS    79/01/20          CREATEB,CBSYN,CBSYNCOM,QDLSYN
                                   QDRSYN,QDLBLD2,EXHIBIT,COMDDIAG
                                   QDLDIAG,CTLSCAN,COMSSLIB 
  
 F2540D3AA  MODS TO DDL AND  FDBF COMMON MODULES TO SUPPORT QU/CDCS 
            SUB-SCHEMA
            JGS  79/02/22       CBPASS1,ARG,CBSIZE,CBINDEX
  
 F2540D3A2 CHANGE VERSION NUMBER TO 3.2                                 000120
          JGS    79/05/29   CTLIO,COMPRFX                               000130
                                                                        000140
 F2540D3A1 CHANGE CBPASS1 TO USE COMMON DECK COMHDRLEN
           JGS   79/05/24    CBPASS1
  
 F2540D3A3 SET FIELDS SBCWSSTYPE AND SBCWCDCS2SB AFTER AVAILABLE
          FIELD LENGTH IS ZEROED OUT. 
          JGS    79/05/29          CBPASS1
  
 F2450D3A4 ISSUE THE SAME DAYFILE MESSAGE FORMAT FOR QU/CDCS AS COBOL 
          JGS    79/05/29    CTLIO
  
 F2540D3A6 FIX UP SOME PROBLEMS WITH GENERATING OVERFLOW HASH TABLE 
           AND SETTING UP SYNONYM/SAMENAME POINTERS.
           JGS   79/06/04    CBINDEX
  
 F31IB07  BREAK UP SYMPL TEXT TSCHTBL SO AS TO REDUCE HHA.
          IJB    6/05/79     TSCHTBL,DCSYNX,CSSYNX
 F2540D3A8 FIX UP SOME PROBLEMS WITH EDITING CHARACTER PROCESSING 
           JGS   79/06/12    CBPASS1
  
 F2540D3A9 CHANGE LEXID OF INDEXED FROM 250 TO 254. INDEXED AND 
           INDEX ARE NOT SYNONYMS. ALSO FIX A PROBLEM WITH
           STORING USAGE TYPE. CHANGE MODLEVEL FROM 3 TO 5 CHARACTERS.
           JGS    79/06/13     CBSYN,CBSYNCOM,CBPASS1,CTLIO 
  
 F2540D3B4 FIX ERROR IN QU/CDCS SUBSCHEMA IF DATANAME IS A MULTIPLE 
           OF 10 CHARACTERS IN LENGTH 
           JGS   79/07/04    CTLSCAN
  
 F2540D3A5 MAKE CWPTR A DEF INSTEAD OF AN ITEM. THIS SPEEDS UP
           EXECUTION TIME. ALSO FIX UP SOME PROBLEMS WITH HASH TABLE
           PROCESSING 
           JGS   79/05/29    CBINDEX
  
 F2540D3B5 IF A REALM HAS MULTIPLE RECORD TYPES, THEN AN ITEM WITH
           THE SAME LOCATION, SIZE AND CLASS AS THE KEY MUST BE 
           SPECIFIED IN ALL RECORD TYPES. 
           JGS   79/07/04    CBINDEX
  
 DL3A012  FIX A MODE 1 THAT OCCURS IN THE SCHEMA IF THE OCCURS
          DEPENDING ON ITEM IS UNDEFINED
           JGS   79/06/16    DLSCHMA,DLSYNTX
  
 F2540D3B2 FIX LOOP IN TRYING TO CHAIN A SYNONYM ENTRY
           JGS   79/07/02    CBINDEX
  
 F2540D3B7 MOVE SQNUMINSRTS FROM WORD 9 TO WORD 11 OF SQBUF THIS
           FIXES PROBLEMS IN PROCESSING EDITED PICTURES IN QU/CDCS
           JGS   79/07/23    CBPASS1
  
 F31IB05  TO CORRECT THE PROBLEM OF THE CHECKSUM BLOCK
          OVER-WRITING THE SUBSCHEMA DIRECTORY WHEN USING FOL.
          IJB    5/3/79      COMSSLIB 
 F2540D3B8 ALL DECIMAL POINTS IN SUBSCHEMA SHOULD BE ASSUMED AND NOT
           ACTUAL 
           JGS   79/08/06    CBPASS1
  
 F2540D3B9 CODE TO SET THE SIGN FLAG IN THE ITEM ENTRY IF THE 
           PICTURE HAS A SIGN, EITHER + OR -
           JGS   79/08/09    CBPASS1
  
 F2540D3C  CODE TO ZERO OUT THE SYNONYM AND SAME NAME POINTER 
           IN THE ITEM ENTRY BEFORE SETTING UP THE HASH TABLE 
           JGS   79/08/13    CBINDEX
  
 F2540D3A6 REWRITE OF ROUTINE DHASH IN CBINDEX. THIS FIXES SEVERAL
           PROBLEMS WITH HASH TABLE PROCESSING. 
           JGS   79/07/19    CBINDEX
  
 F2540D3A7 FIX UP SOME PROBLEMS IN PROCESSING RENAMES/REDEFINES         000880
           FOR QU/CDCS                                                  000890
           JGS   79/06/05    CBSIZE,CBSYN,CBPASS1                       000900
                                                                        000910
 F2540D3C1 SET PIC SIZES FOR RENAMES ITEMS WHICH ARE NOT GROUP ITEMS
           I.E. RENAMES THRU. 
           JGS   79/08/23    CBSIZE 
  
 F2540D3C2 ANOTHER FIX FOR RENAMES/REDEFINES PROCESSING 
           JGS   79/08/27    CBSIZE 
  
 F2540D3B3 ADD LOGICAL AND COMPLEX USAGES TO QU/CDCS SUBSCHEMA
           JGS   79/07/03    CBSYN,CBSYNCOM,CBPASS1,CBCKCNV 
  
 DL3A105  SYNGEN DOES NOT COUNT *UNDEFINED SEMANTIC ROUTINE* IN THE 
          NUMBER OF DIAGNOSTICS REPORTED ON THE DAYFILE 
          JGS    79/09/19    SYNGEN 
  
 DL3A091  PREVENTS THE SPECIFICATION OF ALTERNATE KEYS BEFORE THE 
          PRIMARY KEY IN THE SCHEMA.
          IJB    7/9/79    DCSYNX,DLDIAGM 
 DL3A098  THIS CODE WILL GENERATE A CORRECT GROUP SIZE FOR A GROUP
          ITEM WHOSE USAGE IS NOT DISPLAY OR COMPUTATIONAL.  THE PICTURE
          SNT    79/07/04    QDLSIZE
  
 DL3A099  FIX CBBLDDC SO THAT IT DOES NOT LOOP IF KEY IS REDEFINED
          AS A VECTOR.
          JGS    79/06/11    CBBLDDC
  
 DL3A100  CHANGE ITEM TYPE OF ITEM "CURWORD" FROM CHARACTER(C) TO 
          UNSIGNED INTEGER(U) IN COMMON DECK SCXREFCOM. 
          ALSO, MAKE CORRESPONDING CHANGES TO THE SCHEMA TO CORRECTLY 
          TRANSFER UNSIGNED INTEGER(U) ITEM VALUES INTO CHARACTER(C)
          ITEM FIELDS.
          IJB    7/17/79     SCXREFCOM
 DL3A101  CHANGE DIAGNOSTIC 300 IN THE SCHEMA FROM A TRIVIAL TO A 
          FATAL ERROR.
          IJB    6/25/79      DLDIAGM 
 DL3A103  THIS CODE IS TO MAKE SURE THAT THE PICTURE TYPE 
          CORRESPONDS TO THE USAGE SPECIFIED. 
          SNT    79/07/04          QDLSYN,QDDIAG2 
  
 DL3A107  DD$CCON DOES NOT NORMALIZE FLOATING POINT ZEROES, THUS
          CAUSING RECORD MAPPING ERRORS AT EXECUTION TIME DUE TO
          EXPONENT (2000) BEING GREATER THAN THAT OF ANY OTHER POSITIVE 
          FLOATING POINT NUMBER (17XX)
          JGS    79/09/17    DD$CCON
  
 F2540D3C3 ADD *SEQUENCE IS DISPLAY* TO THE DATA CONTROL ENTRY
           JGS    79/10/25    CBPASS3,DCSYNG,DCSYNX,DLDIAGM 
  
 F2829D3B1 THE SUB-SCHEMA AUDIT DOES NOT LIST SUB-SCHEMA
          NAME(S) CORRECTLY.  WITH THIS CORRECTIVE CODE,
          THE ENTIRE SUB-SCHEMA NAME(S) WILL PUT OUT PROPERLY.
          SNT    79/10/25          QDSSLIB
  
 F2540D3B  SET UNIQUE NAME FLAG FOR RECORD NAMES.                       002110
           JGS    79/06/14    CBPASS1,SBRHDDCLS                         002120
                                                                        002130
 F2829D3C RECOMPILATION ENHANCEMENTS                                    005680
          THE DDL3 SCHEMA COMPILER, TRIGGERED BY AN SB=LFN PARAMETER    005690
          ON THE CONTROL CARD, WILL GO THROUGH THE SUBSCHEMA LIBRARY    005700
          FILE AND FLAG ALL SUBSCHEMAS, BELONGING TO THAT SCHEMA        005710
          THAT MUST BE RECOMPILED                                       005720
          JGS    79/09/26          LOADOVL,CREATEB,DLRELN,SCXREFCOM     005730
                                   SCHEMIO,ARG,COMHDRLEN,CKSUBIO,DLCKSUB005740
                                                                        005750
 DL3A103A THIS CODE IS TO CHANGE THE PREVIOUS SELECTED DIAGNOSTIC 
          NUMBER 142 TO 144 FOR ERROR MESSAGE-  PICTURE TYPE DOES 
          NOT CORRESPOND TO USAGE TYPE. 
          SNT    79/09/26          QDLSYN,QDDIAG2 
  
 DL3*80   UPDATE COPYRIGHT INFORMATION TO 1980
          JGS    79/10/24          CNTRL,SYNGEN 
  
 DL3A108  THIS CODE IS TO DIAGNOSE ANY KIND OF INVALID CONSTRUCTION OF A
          RESTRICT CLAUSE.  SCANNING RESUMES AT THE NEXT RELATION ENTRY.
          DIAGNOSTIC NO. 77 WILL BE ISSUED TO THAT EFFECT.
          SNT    79/10/11          COMDDIAG,QDDIAG1,QDRSYNX 
          (EQUIVALENT OF DL2A214) 
  
 DL3A109  CHANGE *EQ* INSTRUCTION TO *RJ* INSTRUCTION TO AVOID MODE 0 
          JGS    79/10/04    LOADOVL
  
 DL30008  THE SCHEMA AND SUB-SCHEMA NAMES ARE BEING TRUNCATED TO
          10 CHARACTERS IN SUB-SCHEMA LIBRARY AUDIT.  WITH THE
          CORRECTIVE CODE, THE ENTIRE SCHEMA AND SUB-SCHEMA NAMES ARE 
          PUT OUT PROPERLY. 
          SNT    79/10/25          CBSSLIB
  
 DL3A106  CODE TO CALL DSR BEFORE SETTING X$MSSO
          JGS    79/08/10    COMGEN 
  
 DL3A104  DDL DIAGNOSES HMB = 0 FOR DA FILES AND SETS A DEFAULT VALUE.
          IJB    8/13/79     DCSYNX,DLDIAGM 
 DL30004  THIS CODE IS TO PUT OUT DIAGNOSTIC 037 WITH THE CORRECT 
          AREA NAME.
          SNT    79/07/27          QDLSIZE,QDLBLD2
          (EQUIVALENT OF DL2A211) 
  
 DL3A093  TO CORRECT THE PROBLEM OF SUBSCHEMA CHECKSUMS CHANGING FOR
          IDENTICAL SUBSCHEMAS. 
          IJB    3/19/79     CBBLDDC
 F2540D3C4 FIX A PROBLEM INTRODUCED BY ADDING ALL THE DDL 3.1           011124
            OUTSTANDING CODE TO DDL 3.2.                                011125
           JGS   12/03/79          QDDIAG2                              011126
                                                                        011127
 F2540D3C5 FIX SCANNER SO THAT NO DIAGNOSTIC IS ISSUED FOR A BLANK LINE 
           JGS   12/04/79          CTLSCAN
  
F2829D3AA PROBLEM - WHEN GENERATIN A DBP LIST TO BE PRINTED OUT, THE    011163
                    SCHEMA NAME IS BEING BLANK FILLED BEFORE            011164
                    WRITING IT OUT TO THE DIRECTORY.                    011165
           SOLUTION - BLANK IT OUT AFTER THE DIRECTORY IS WRITTEN.      011166
           JGS   12/10/79          DLRELN                               011167
                                                                        011168
 DL3A112  PROBLEM - DDL ABORTS WITH MEM ARG ERROR IF PASS3 TRIES
                    GET MORE FIELD LENGTH.
          SOLUTION - CHANGE CBPASS3 SO THAT IT CALLS MEMORY WITH TOTAL
                     FL TO BE REQUESTED INSTEAD OF DIFFERENCE BETWEEN 
                     OLD FL AND NEW FL. 
          JGS    12/11/79          CBPASS3
  
 DL2A218  QU/DDL DEFINED THE DOMINANT ITEM POINTER AS A 12-BIT FIELD
          IN THE SUB-SCHEMA DIRECTORY.  THIS CAUSED TRUNCATION IF THE 
          POINTER EXCEEDED 7777B (4095).
          SOLUTION:  THE DOMINANT ITEM POINTER (SBITMDOMPTR) HAS BEEN 
          EXTENDED TO 18 BITS.
          SNT    79/11/12          QDLBLD2
          (EQUIVALENT OF DL2A218) 
  
 DL3A114  PROBLEM - DDL DIRECTORY ACCESS ROUTINE WRITES INDEX BLOCK OVER
                    CODE IF A LARGER OVERLAY IS LOADED FOLLOWING A
                    SMALLER, BOTH USING THE DAR.
          SOLUTION - DELETE CODE WHICH USES THE INDEX WSA ADDRESS IN THE
                     SCHEMA TABLE IF THIS VALUE IS NON-ZERO. THIS 
                     CAUSES AN INTERNAL WSA TO BE USED AT ALL TIMES.
          DTC    11/12/79    DA$NMSC
          SRN = (DL3A114) 
  
DL30007   PROBLEM - SUBSCHEMA COMPILER DOES NOT DIAGNOSE A REDEFINES
                    ENTRY WHICH DOES NOT FOLLOW THE REDEFINED ITEM
          SOLUTION - FIX THE SUBSCHEMA COMPILER TO CHECK THAT IF THE
                     PRIOR ITEM NAME DOES NOT MATCH, IT MUST BE PART
                     OF A REDEFINED ITEM ENTRY
          JGS    11/05/79          CBPASS1,CBDIAGM
  
 F2540D3C6 FIX PROBLEM OF TOO MANY DIAGNOSTICS BEING ISSUED FOR 
           ILLEGAL PICTURES 
           JGS   12/27/79          CBPASS1,PICTURE
  
 F2540D3B1 IF AN AREA HAS MULTIPLE RECORD TYPES, THEN AN ITEM WITH
           THE SAME LOCATION, SIZE AND CLASS AS THE KEY MUST BE 
           SPECIFIED IN ALL RECORD TYPES. 
           JGS   79/06/25    DCSYNX 
  
 DL30007A A BUG IN THE ORIGINAL CODE CAUSES DIAGNOSTIC 207 TO BE
          ISSUED INSTEAD OF DIAGNOSTIC 173. THIS FIXES THE PROBLEM
          SO THAT DIAGNOSTIC 173 IS ISSUED PROPERLY.
          JGS    12/21/79          CBPASS1
  
 DL3A117  PROBLEM - COBOL SUBSCHEMA COMPILER GETS CM OUT OF RANGE ERROR 
                    IN PICTURE. 
          SOLUTION - ALTER *EQ* TO MODIFIED ADDRESS TO *RJ* TO THE
                     ADDRESS PLUS ONE TO VOID THE STACK.
          DTC   01/10/80    PICTURE 
          SRN = (DL3A117) 
  
 DL3A111  PROBLEM - COBOL FAILS TO RECOGNIZE *ALIASED* REALM
                    NAMES WHEN *REALM ALL* DIRECTIVE SPECIFIED IN THE 
                    SUB-SCHEMA. 
          SOLUTION - ALTER SUB-SCHEMA COMPILER TO COMPARE SCHEMA REALM
                     NAME TO OLD SUB-SCHEMA NAME. IF A MATCH EXISTS 
                     SET UP THE AREA ENTRY COMPLETE WITH AN ALIAS ENTRY.
          JGS    10/04/79    CBPASS1
  
 F32JS01  THIS CODE PURGES IDENTS DL30012 AND DL30013 WHICH SHOULD
          NOT HAVE BEEN USED SINCE THEY CONFLICT WITH REAL PSR NUMBERS. 
          THIS CODE READDS THE CODE GENERATED BY THOSE TWO IDENTS 
          JGS    02/01/80          CBPASS3,SBRLDBDCL,DCSYNX 
  
 F32JS02  CODE TO CUT DOWN THE SIZE OF DDL LISTINGS. IT DELETES 
          THE CALL TO THE COMMON DECKS WHICH ARE PART OF SYMPL TEXTS
          JGS    02/08/80          DCSYNX,CBPASS1,CBSIZE,CBINDEX,RELSTAT
                                   CBCKREC,CBCKSCM,CBBLDDC,CBCKITM
                                   CBCKSS,CBCKOC,CBCKEL,CBCKAR,CBCKCNV
                                   CBDBPBD,CBSSITA,CBSSRCA,CBSTBCK
                                   CBERROR,CBCLNUP,CBPASS3,DL10,DLRELN
                                   DLSCHMA,DLSIZE,CSSYNX,DLHASH 
  
 DL3A115  PROBLEM - INVALID SCHEMA TYPE DECLARATION GENERATES 
                    INVALID DIAGNOSTICS.
          SOLUTION - IF UNRECOGNIZABLE SYNTAX IS ENCOUNTERED
                     ISSUE DIAGNOSTIC 346 INDICATING UNRECOGNIZABLE 
                     SYNTAX AND THAT WE ARE SKIPPING TO A PERIOD
                     BEFORE CONTINUING SCANNING.
                     COMBINE THE DATA CLASS AND SIZE SETTING ROUTINES 
                     THAT EXIST FOR EACH NUMERIC OPTION INTO ONE TO 
                     ELIMINATE ORDER DEPENDENCY.
                     CREATE A DIAGNOSTIC AND CHECK FOR THE
                     OCCURANCE OF AN INVALID TYPE OPTION. 
                     CORRECT THE REFERENCE MANUAL DESCRIPTION 
                     OF THE TYPE STATMENT.
          DTC    01/09/80    DLSYNTX,DLSCHMA,DLDIAGM,SCSYNCOM 
          SRN =(40035)
  
 DL3A116  FIX ERRONEOUSLY ISSUED DIAGNOSTIC 180 
          JGS    12/17/79          QDLSYN,QDDIAG2,QDSYNTX 
  
 DL3A120  PROBLEM - SUBSCHEMA RECOMPILATION REPORT IS NOT GENERATED 
                    IF DBPS ARE SPECIFIED IN THE SCHEMA 
          SOLUTION- MODIFY DLRELN NOT TO BLANK FILL THE SCHEMA NAME 
                    IN THE CONTROL WORDS. INSTEAD MOVE THE SCHEMA 
                    NAME TO A TEMPORARY ARRAY AND THEN BLANK FILL IT. 
          JGS    02/08/80          DLSCOM,DLRELN,DLCKSUB
  
 DL3A118  PROBLEM - PASS3 DOES NOT ENFORCE THAT IDENTIFIERS TO THE
                    LEFT AND TO THE RIGHT OF THE OPERATOR ARE SIMILAR 
                    IN TYPE.
          SOLUTION- CHANGE PASS3 TO ENFORCE THE RULE: BOTH IDENTIFIERS
                    MUST BE DISPLAY CODED DATA (CLASS LQ 4) OR MUST BE
                    THE SAME TYPE OF BINARY DATA (SAME CLASS).
               THIS CODE ALSO CHANGES PASS3 TO USE COMDECK *COMHDRLEN*
          JGS       01/28/80       CBPASS3,CBRDAGM
  
 *L528*    ************************************************ 
 DL3A115A PROBLEM - DEFAULT SIZE OF CHARACTER ITEMS IS NOT SET TO 1.
          SOLUTION- FIX SEMANTIC ROUTINE SETCHAR TO SET DEFAULT SIZE
                    OF CHARACTER ITEMS TO 1 
          JGS    03/19/80          DLSCHMA
  
 DL3A121  PROBLEM - MAXIMUM RECORD LENGTH DOES NOT CONFORM TO AAM 2 
                    RESTRICTIONS
          SOLUTION- MODIFY SCHEMA AND SUBSCHEMA COMPILERS TO CHECK
                    FOR RECORD LENGTH GQ 81870 INSTEAD OF 262143
          JGS    03/18/80          DLSCHMA,CBSIZE,CBPASS1,CBDIAGM 
  
 DL3A122  PROBLEM - DIAGNOSTIC NUMBER 314 HAS BEEN USED FOR  DIFFERENT
                    DIAGNOSTIC MESSAGES 
          SOLUTION- CHANGE DIAGNOSTIC NUMBER 314 TO 316 
          JGS    03/03/80          CBINDEX
  
 DL3A123  PROBLEM - WHEN PRINTING DIAGNOSTIC 997, ONLY THE FIRST
                    CHARACTER OF THE AREA NAME IS PRINTED, AND IS 
                    PRINTED ONCE FOR EACH CHARACTER IN THE AREA NAME
          SOLUTION- FIX DCSYNX SO THAT ALL CHARACTERS ARE MOVED 
                    TO THE MESSAGE INSTEAD OF ONLY THE FIRST ONE
          JGS    04/08/80          DCSYNX 
  
 DL3A124  PROBLEM - SCHEMA COMPILER DOES NOT DIAGNOSE KEY LENGTHS 
                    GREATER THAN 240 CHARACTERS 
          SOLUTION- MODIFY DCSYNX TO ISSUE DIAGNOSTIC 150 IF THE
                    LENTGH OF THE ITEM DEFINED AS KEY EXCEEDS 240 
                    CHARACTERS
          JGS    04/10/80          DCSYNX,DLDIAGM 
  
 DL30006  PROBLEM - SCHEMA COMPILER DOES NOT ENSURE THAT KEYS ARE 
                    SPECIFIED IN THE FIRST RECORD TYPE WITHIN THE AREA
          SOLUTION- FIX DCSYNX SO THAT IT ISSUES A DIAGNOSTIC IF
                    THE KEYS ARE NOT DEFINED IN THE FIRST RECORD TYPE 
          JGS    02/13/80          DCSYNX,DLDIAGM 
  
 DL30009  PROBLEM - SUBSCHEMA COMPILER FAILS TO FIND QUALIFIED
                    ALIAS DATA NAMES. 
          SOLUTION- FIX CBPASS1 TO FOLLOW THE SYNONYM POINTER IN THE
                    ALIAS ENTRY, IF THE THERE IS ONE AND THE DOMINANT 
                    ITEM NAME DOES NOT MATCH THE QUALIFIER NAME 
          JGS    04/09/80          CBPASS1
  
 *L538*    ************************************************ 
         THIS IDENT UPDATES COPYRIGHT INFORMATION 
         TO 1981. 
         HSW     08/12/80     SYNGEN,CNTRL
  
 DL3A130  PROBLEM -- ONCE DIAG 287 IS ISSUED FOR A RECORD THAT EXCEEDS
                 THE MAXIMUM ALLOWABLE SIZE, THE SAME ERROR MESSAGE WILL
                 BE ISSUED FOR ALL THE RECORDS THAT FOLLOW. 
          SOLUTION -- DEFINE A VARIABLE RECORDERR IN DLSCHMA TO COUNT 
                 THE NUMBER OF ERRORS IN THE RECORD.  IF NUMBER OF
                 ERRORS IS ZERO, THEN DLSIZE WILL BE CALLED TO
                 COMPUTE THE SIZE OF THE RECORD.
          HSW    06/23/80    DLSCHMA
  
 DL3A131  PROBLEM - MANY PROBLEMS IN SYNGEN ARE ADDRESSED:  
            1. SYNGEN WILL OCCAISIONALLY STOP PROCESSING BEFORE IT HAS
               COMPLETED ITS INPUT. THIS IS RECOGNIZED BY THE LACK OF 
               A DAYFILE MESSAGE PROCLAIMING *SYNGEN COMPLETE*. 
            2. THE REQUIRED FL REPORTED BY SYNGEN IS NOT ACCURATE.
            3. SYNGEN HAS NO PROVISION FOR AN ABORT-ON-ERRORS CONTROL 
               STATEMENT PARAMETER AS DO COMPASS, SYMPL, ETC. 
            4. SYNGEN ALLOWS NO USER CONTROL OF PAGINATION. 
  
          SOLUTION - THE SOLUTIONS FOR THE ABOVE PROBLEMS ARE:  
            1. A LOGIC ERROR IN PROC WALKCHAIN CAUSED THAT PROC TO
               ERRONEOUSLY DETECT A BROKEN CHAIN OF FORWARD REFERENCES
               TO A SUBLABEL. A TRAP EXISTED FOR SUCH BREAKS - IT 
               RESULTED IN A SYMPL *STOP*. THIS IDENT CORRECTS THE LOGIC
               ERROR AND CHANGES THE TRAP TO ABORT SYNGEN AND ISSUE A 
               DAYFILE MESSAGE PROCLAIMING *INTERNAL ERROR (WALKCHAIN)*.
            2. THE FL DETERMINATION LOGIC FAILED TO INCLUDE THE INITIAL 
               OFFSET OF SYNTBLE, AND COUNTED SOME ALLOCATIONS TWICE. 
               THUS THE FL COULD BE OFF IN EITHER DIRECTION. THIS IDENT 
               CORRECTS THE FL DETERMINATION LOGIC TO ACCURATELY REPORT 
               THE REQUIRED FL. 
            3. A NEW CONTROL STATEMENT PARAMETER IS ADDED. THE *A*
               CONTROL STATEMENT PARAMETER WILL CAUSE SYNGEN TO ABORT 
               AFTER PROCESSING ALL INPUT IF ANY ERRORS OCCURRED ON ANY 
               OF THE PROCS. SUCH AN ABORT WILL RESULT IN A DAYFILE 
               MESSAGE PROCLAIMING *SOURCE ERRORS -- ABORT REQUESTED*.
               THIS MESSAGE WILL OCCUR AFTER THE *SYNGEN COMPLETE*
               MESSAGE. 
            4. A NEW COMPILER DIRECTIVE IS ADDED TO ALLOW A USER REQUEST
               TO SKIP TO THE TOP OF A NEW PAGE. THE SYNTAX IS #EJECT#, 
               WITH THE FIRST DELIMITER OCCURRING IN THE FIRST CHARACTER
               POSITION OF THE INPUT RECORD.
          CFR    80/07/11    SYNGEN 
  
 *L552*    ************************************************ 
 DL30013  PROBLEM -- IF AN AREA THAT CONTAINS MORE THAN ONE RECORD
                 IS INVOLVED IN A RELATION, THEN DDL WILL ABORT WITH ERROR
                 MODE 1.
          HSW    07/09/80     QDRSYN
  
 DL30014  PROBLEM -- ROUTINE DE$IO SETS MRL PARAMETER FOR SUBSCHEMA 
                 LFN TOO SMALL. 
          SOLUTION -- CHANGE MRL IN FIT TO 100000.
          HSW    11/03/80    DA$IO
  
 *L564*    ************************************************ 
 DL3A138  PROBLEM  -  AN APPLICATION PROGRAM ACCESSING A SUBSCHEMA
                      FILE CONTAINING MORE THAN 25 REALMS, GETS A 
                      COMPILATION TIME ERROR STATING THAT THE 
                      SUBSCHEMA FILE IS INACCESSIBLE. 
          SOLUTION -  SET THE LOOP VARIABLE USED BY DA$NMSB 
                      AFTER ALL THE REALMS ARE PROCESSED. 
          RMP    81-12-15    DA$NMSB
  
 DL30018  PROBLEM  - ERROR IN THE GENERATION OF MAPPING CAPSULES CAUSES 
                     CDCS MODE ERRORS.
                     WHEN APPENDING THE MAPPING CAPSULE TO THE SUBSCHEMA
                     DIRECTORY, THE POINTER TO THE CAPSULE IS NOT 
                     CHANGED. 
                     THIS CAUSES THE NEXT CAPSULE TO BE BUILT IN THE
                     SPACE WHERE THE CURRENT CAPSULE IS STORED. 
          SOLUTION - WHEN TCAP IS APPENDED TO TSUB, P<TCAP> MUST BE 
                     RESET TO BE OUTSIDE THE ENLARGED TSUB AREA.
          RLM     82/02/23   COMPASS2, PASS2
  
         THIS IDENT UPDATES COPYRIGHT INFORMATION 
         TO 1982. 
         PJR     09/03/81     SYNGEN,CNTRL
  
 *L577*    ************************************************ 
 DL30022  PROBLEM  - CRM ERROR 502 WAS RETURNED WHEN A USER PROGRAM 
                     TRIED TO READ VIA AN ALTERNATE KEY WHICH IS
                     SUBORDINATE TO ANY GROUP.  THIS OCCURRED BOTH
                     THROUGH THE COBOL AND QU INTERFACES. 
                     THE CODE THAT GENERATES THE KEY MAPPING CAPSULES 
                     DURING SUBSCHEMA COMPILATION STOPPED ONE ITEM
                     SHORT WHEN FOLLOWING THE DOMINANT ITEM CHAIN 
                     WHILE CALCULATING THE SCHEMA RKW AND RKP OF THE
                     ALTERNATE KEY.  SINCE IT DOES NOT CALCULATE THE
                     CORRECT RKW AND RKP, THE VALUES STORED IN THE
                     FIT WILL BE WRONG, AND THE 502 ERROR WILL OCCUR. 
          SOLUTION - SAVE THE DOMINANT ITEM POINTER IN A SEPARATE 
                     ITEM SO THE LOOP CAN EXPLICITLY TEST TO SEE IF 
                     A FURTHER DOMINANT ITEM EXISTS.
          CFR     82/01/08   COMAPKEY 
  
 DL30025  PROBLEM  - AN APPLICATION PROGRAM IS UNABLE TO ACCESS MORE
                     THAN 25 REALMS IN A REALM LIST.
                     THE PROBLEM EXISTS IN THE REALM LIST SEARCH LOOP 
                     IN THE ROUTINE DE$RCSB(CONTAINED IN THE ROUTINE
                     DE$NMSB). A SIMILAR PROBLEM WAS FIXED IN THE REALM 
                     LIST SEARCH LOOP IN THE ROUTINE DE$ARSB(ALSO 
                     CONTAINED IN DE$NMSB) BY PSR DL3A138.  THE PROBLEM 
                     IS THAT THE ADDRESS TO BEGIN READING THE REALM LIST
                     FROM IS INITIALIZED INSIDE THE LOOP INSTEAD OF 
                     OUTSIDE. THE ROUTINE THAT READS THE REALM LIST,
                     DE$READ, SUBTRACTS FROM THAT ADDRESS THE NUMBER OF 
                     WORDS READ TO PREPARE FOR THE NEXT READ IF ANY. THE
                     MAXIMUM NUMBER OF WORDS PER READ IS 100 OR 25
                     REALMS. IF THERE ARE MORE THAN 25 REALMS IN THE
                     LIST THEN A SECOND EXECUTION OF THE SEARCH LOOP
                     WILL TAKE PLACE. BECAUSE THE ADDRESS TO BEGIN
                     READING THE REALM LIST FROM IS INITIALIZED INSIDE
                     THE LOOP, THE FIRST 25 REALMS OR LESS WILL BE READ 
                     IN AGAIN.
          SOLUTION - INITIALIZE THE REALM LIST ADDRESS OUTSIDE THE
                     LOOP INSTEAD OF INSIDE.
          EPJ/ASE 82/04/20   DE$RCSB
  
 *L587*    ************************************************ 
 DL3A143  PROBLEM  - THE DDL3 DEFAULT FILE ORGANIZATION FOR QU/CRM SUBSCHEMA'S
                     IS *OLD*. THIS CAUSES PROBLEMS ON NOS2 WHEN AAM1 IS NOT
                     AVAILABLE.  PROBLEMS SUCH AS CRM ERROR 347 AND POSSIBLY
                     EVEN A MODE ERROR OCCUR IF QU ATTEMPTS TO ACCESS AN
                     ORGANIZATION *OLD* (INITIAL) FILE WHEN AAM1 IS NOT 
                     PRESENT. 
          SOLUTION - THE DDL3 DEFAULT FILE ORGANIZATION FOR QU/CRM SUBSCHEMA'S
                     IS CHANGED FROM *OLD* TO *NEW*.  IF AAM1 IS AVAILABLE
                     AND INITIAL FILE (ORGANIZATION *OLD*) USAGE IS DESIRED,
                     VIA QU, THEN ORGANIZATION *OLD* MUST BE EXPLICITLY 
                     SPECIFIED IN THE SUBSCHEMA COMPILER INPUT. 
          EPJ/CKJ 83/02/05   QDLSYN, QDSYNTX
  
 DL30023  PROBLEM  - THE BEGINNING WORD AND BIT POSITIONS FOR A 
                     REDEFINES ITEM, THE SIZE OF A REDEFINES ITEM 
                     IF ITS THE LAST ITEM IN A RECORD, AND THE SIZE 
                     AND BEGINNING WORD AND BIT POSITIONS OF AN ITEM
                     WITH A REDEFINES CLAUSE IF THERE IS ANOTHER
                     RECORD FOLLOWING ARE NOT BEING SET PROPERLY. 
          SOLUTION - THE EQUATION TO CALCULATE THE BWP SHOULD DO AN 
                     ADDITION OPERATION INSTEAD OF MULTIPLICATION.
                     THE SIZE OF A REDEFINES ITEM IF ITS THE LAST 
                     ITEM IN THE RECORD WAS NOT BEING SET PROPERLY
                     DUE TO THE POINTER BEING SET TO THE PREVIOUS 
                     ITEM WORK BUFFER.  SAVE THE CURRENT WORK BUFFER
                     BEFORE EXITING FROM LOOP IN PROC REDEFLVL66. 
                     THE SIZE AND BEGINNING WORD AND BIT POSITIONS OF 
                     AN ITEM WITH A REDEFINES CLAUSE ARE NOT SET
                     PROPERLY IF THERE IS ANOTHER RECORD FOLLOWING
                     IT DUE TO THE RECORD POINTER BEING SET TO THE
                     NEXT RECORD BEFORE THE PREVIOUS RECORD IS
                     COMPLETELY PROCESSED.  SET THE RECORD POINTER
                     TO THE FIRST WORD OF THE NEXT RECORD AFTER THE 
                     PREVIOUS RECORD HAS BEEN COMPLETELY PROCESSED. 
          ASE/EPJ 82/07/27   CBSIZE, CBPASS1, CBSYN 
  
 DL30029  PROBLEM  - THE KEY MAPPING CAPSULE EXPECTS THE RECORD ORDINAL 
                     THAT IS PASSED TO BE THE ORDINAL WITHIN THE
                     REALM LIST.
                     CDCS PASSES THE ORDINAL OF THE RECORD WITHIN THE 
                     SCHEMA.
                     IF KEY MAPPING IS REQUIRED FOR AN AREA THAT HAS
                     MULTIPLE RECORD TYPES, THE KEY MAPPING WILL NOT
                     BE PERFORMED CORRECTLY UNLESS THE AREA IS THE FIRST
                     ONE IN THE SCHEMA. 
          SOLUTION - THE MAPPING CAPSULE WILL CONVERT THE RECORD ORDINAL
                     TO THE PROPER REALM LIST RECORD JUMP INDEX.
          RLM     82/07/19   MAPKEY 
  
 DL30031  PROBLEM  - DDL3 LOOPS DURING PROCESSING OF A QU SUBSCHEMA 
                     IF A REDEFINES GROUP CONTAINS A NESTED GROUP.
          SOLUTION - THE PROCESSING OF REDEFINES ENTRIES BY THE 
                     PROCEDURE REDEFLVL66 IS REWRITTEN TO HANDLE
                     MULTIPLE LEVELS OF NESTED GROUPS.
          RLM     83/01/10   CBSIZE 
  
 DL30032  PROBLEM  - THE DDL SUBSCHEMA COMPILER LOOPS UNTIL TIME LIMIT
                     PROCESING A QU/CDCS SUBSCHEMA. 
                     THE PROBLEM INVOLVES THE BUILDING OF THE AREA HASH TABLE 
                     USED BY QU. THE PROBLEM OCCURRED BECAUSE THE RECORD
                     SYNONYM ADDRESS, WHICH HAD BEEN SET DURING A PREVIOUS
                     HASH, WAS NOT ZEROED OUT BEFORE THE HASH USED IN THE 
                     BUILDING OF THE QU AREA HASH TABLE. THIS CAUSED THE ITEM 
                     THAT WAS SYNONYMOUS WITH THE RECORD TO HAVE A SYNONYM
                     ADDRESS POINTING TO ITSELF. WHEN THE SYNONYM ADDRESS 
                     CHAIN WAS NEXT PROCESSED, THE ITEM WITH THE
                     ADDRESS POINTING TO ITSELF CAUSED THE LOOP TO TIME 
                     LIMIT. 
          SOLUTION - ZERO OUT THE RECORD SYNONYM ADDRESS BEFORE THE NAME
                     IS HASHED. 
          EPJ     82/12/01   CBINDEX
  
 *L601*    ************************************************ 
 DL3A149  PROBLEM  - CODE IS NEEDED TO SUPPORT 8 LINES PER INCH 
                     PRINT DENSITY. 
          SOLUTION - ADD THE CODE TO SUPPORT 8 LINES PER INCH PRINT 
                     DENSITY. 
          EPJ     83/04/29    ARG, CTLIO, SYNGEN
  
 DL30035  PROBLEM  - USE OF LEVEL 88 VALUE CLAUSES IN A SUBSCHEMA 
                     MAY CAUSE THE INCOMPLETE GENERATION OF READ
                     MAPPING CAPSULES OR KEY MAPPING CAPULES. 
                     THIS RESULTS IN GARBAGE BEING READ AS INPUT
                     WHEN IT IS THE READ MAPPING CAPSULE. 
                     KEY MAPPING CAPSULES MAY BE OMITTED ENTIRELY.
                     IT MAY ALSO CAUSE KEY MAPPING ROUTINES TO BE 
                     ASSOCIATED WITH THE WRONG ITEM ORDINAL.
                     THAT RESULTS IN INCORRECT RANDOM READS OR STARTS.
          SOLUTION - RESTRUCTURE THE LOOP CONTROLS IN MAPKEY
                     AND IN MAPRD.
          RLM     83/01/24    MAPRD, MAPKEY 
  
 DL30039  PROBLEM  - INCORRECT DATA IS SOMETIMES WRITTEN BY CDCS FOR
                     RECORDS THAT CONTAIN REPEATING GROUPS (OCCURS
                     CLAUSE).  THIS HAPPENS BECAUSE THE MAPPING BLOCKS
                     IN THE SUBSCHEMA ARE SET INCORRECTLY UNDER THE 
                     FOLLOWING CIRCUMSTANCES: 
                     THE REPEATING GROUP APPEARS LAST IN THE RECORD 
                     DESCRIPTION;  THE LEVEL OF THE LAST ITEM IN THE
                     GROUP IS LESS THAN THE LEVEL OF THE PREVIOUS ITEM. 
          SOLUTION - MODIFY THE END OF RECORD DETECTION SO THAT THE 
                     CHECK AND THE SETTING OF THE "ENDOFRECORD" FLAG ARE
                     DONE AFTER THE LAST ITEM HAS BEEN PROCESSED. 
          EPJ     83/04/16   CBSTBCK
  
 *L617*    ************************************************ 
 DL3A150  PROBLEM  - DDL MODE 1 ERROR WHEN RUNNING QU/CRM COMPILER
                     WITH NO RFL CONTROL STATEMENT TO INCREASE FL.
                     CAUSED BY INADEQUATE INTERNAL TESTING OF MEMORY
                     USE. 
          SOLUTION - CHANGE MEMORY USE TESTS TO LOOK AHEAD AT 
                     THE NEXT MEMORY USE REQUIREMENTS.
          GFK     83/06/24   DL30301
  
 DL3A153  PROBLEM  - DDL ISSUES A -FILE CARD MISSING- ERROR MESSAGE 
                     WHEN THE PROBLEM IS A BAD LITERAL OCCURRING IN THE 
                     PICTURE CLAUSE IN AN ITEM DECLARATION. 
                     CAUSED BY A CODING ERROR.
          SOLUTION - CHANGE THE ERRONEOUS ERROR NUMBER. 
          GFK     83/06/23   DLSYNTX
  
 DL30036  PROBLEM  - DDL GIVES ERRONEOUS ERROR MESSAGES (PRIMARY KEY
                     ALREADY SPECIFIED) WHEN COMPILING A QU/CRM 
                     SUBSCHEMA WITH A COLLATING SEQUENCE LITERAL
                     CONTINUED ON A SECOND LINE.  CAUSED BY THE OVERLAP 
                     OF TWO VARIABLES.
                     ALSO, A BLANK WAS BEING LEFT IN THE LITERAL AS IT
                     APPEARED IN MEMORY.  CAUSED BY THE FAIURE TO 
                     HANDLE A QUOTATION MARK IN A LITERAL.
          SOLUTION - MOVE THE COLLATING LITERAL LENGTH VARIABLE SO
                     THAT IT DOES NOT OVERLAP OTHER VARIABLES.
                     REDUCE BY ONE THE INPUT RECORD LENGTH WHEN A DOUBLE
                     QUOTE MARK IS RECOGNIZED AS A QUOTE EMBEDDED IN A
                     LITERAL. 
          GFK     84/01/23   CLTSCAN, QDLBLD2, QDLSYN 
  
 DL30038  PROBLEM  - DDL COMPUTING INCORRECT RECORD SIZE FOR QU/CRM 
                     SUBSCHEMAS CONTAINING GROUP ITEMS.  CAUSED BY
                     SETTING WORD ADJUST BIT FOR GROUP ITEMS WHEN 
                     A MEMBER OF THE GROUP NEEDED TO START ON 
                     A NEW WORD BOUNDARY. 
          SOLUTION - MAKE ITEMS START ON WORD BOUNDARY WHEN NEEDED
                     (E.G., COMP-1 ITEMS) WITHOUT AFFECTING THE 
                     GROUP THEY BELONG TO, UNLESS THE ITEM IS THE FIRST 
                     IN THE GROUP, IN WHICH CASE MAKE THE GROUP ITEM
                     START ON A WORD BOUNDARY.  ALSO MAKE GROUP ITEMS 
                     CANDIDATES FOR WORD ADJUSTING
                     (E.G. 02 ANAME USAGE IS INTEGER).
          GFK     83/01/17   QDLSIZE
  
 DL30040  PROBLEM  - SUBPARTS OF -CHECK IS- CLAUSE WERE ORDER 
                     DEPENDENT (SHOULD NOT HAVE BEEN); USE OF 
                     -PICTURE- SUBPART INHIBITED MAPPING CAPSULES 
                     FOR VALUE AND DATABASE PROCEDURES FROM BEING 
                     GENERATED. 
                     ORDER DEPENDENCY CAUSED BY BEING CODED WITH NO 
                     EFFORT TOWARD ORDER INDEPENDENCY.
                     CAPSULE INHIBITION CAUSED BY BEING CODED 
                     WITH THAT AS GOAL. 
          SOLUTION - REWRITE SNYTAX CRACKER TO ACCEPT CLAUSE SUB- 
                     PARTS IN ANY ORDER.
                     REWRITE SEMANTIC ROUTINES SO THAT -PICTURE-
                     INHIBITS MAPPING CAPSULE ONLY IF NO DBP OR 
                     VALUE SUBPARTS OCCURE. 
          GFK     83/06/29   DL30101,CBCKSCM,DLSYNTX,SCIHDDCLS
  
 DL30041  PROBLEM  - WHEN AN ALIAS NAME IS QUALIFIED BY THE RECORD NAME 
                     AND THE ALIAS NAME IS SUBORDINATE TO A GROUP ITEM, 
                     THE ALIAS NAME IS NOT ASSOCIATED WITH THE SCHEMA 
                     ITEM AND ERROR 302 RESULTS:  
                     "SUBSCHEMA ITEM DOES NOT APPEAR IN THE SCHEMA".
                     PSR DL30009 MODIFIED THE CODE TO SEARCH FOR A
                     MATCHING QUALIFIER NAME SO THAT IT WOULD SEARCH
                     THE SYNONYM CHAIN IF THE FIRST DOMINANT ITEM DOES
                     NOT MATCH THE QUALIFIER NAME.  THE SEARCH OF THE 
                     ALIAS SYNONYM CHAIN WAS NECESSARY FOR THE CASE 
                     WHERE TWO ALIAS NAMES ARE THE SAME BUT ARE 
                     QUALIFIED TO BE IN DIFFERENT RECORDS.  IN PUTTING
                     IN THE SYNONYM SEARCH DL30009 REMOVED THE
                     COMPARISION OF THE QUALIFIER AGAINST OTHER 
                     DOMINANT ITEMS WITHIN THE RECORD.
          SOLUTION - MODIFY THE SEARCH FOR A MATCHING QUALIFIER NAME SO 
                     THAT ALL DOMINANT ITEMS ARE COMPARED BEFORE
                     SEARCHING THE ALIAS SYNONYM CHAIN. 
          EPJ     83/08/14   CBPASS1
  
 DL30042  PROBLEM  - MODE ERROR OCCURS DURING RECORD MAPPING OF A RECORD
                     THAT CONTAINS A REPEATING ITEM WITH A VARIABLE 
                     COUNT ( T TYPE RECORD ) AND THE REPEATING ITEM 
                     HAS A CHECK VALUE CLAUSE.
                     THIS ONLY HAPPENS WHEN THE REPEATING ITEM IS ONE 
                     THAT DOES NOT REQUIRE ANY CONVERSION OF DATA CLASS,
                     SCALING CHECKS OR OTHERWISE NEEDS A PROCEDURE CALL 
                     IN ORDER TO MOVE IT TO THE TARGET RECORD.
                     IN THIS CASE A REGISTER CONFLICT WITHIN THE MAPPING
                     CAPSULE CAUSES AN ENDLESS LOOP WHICH DESTROYS CDCS 
                     MEMORY.
          SOLUTION - MOVE TWO LINES OF CODE IN COMGLC.
          RLM     83/08/11   GLC
  
 DL30045  PROBLEM  - CDCS FAILS TO FIND MATCHING DATA FOR RESTRICTED
                     RELATION, WHEN LITERAL GIVEN IS SHORTER THAN 
                     DATA ITEM (OF TYPE CHARACTER). CAUSED BY DDL ZERO
                     FILLING RESTRICT ITEM THAT IS COMPARED TO BLANK
                     FILLED ITEM. 
          SOLUTION - BLANK FILL THE LITERAL WHEN IT IS PROCESSED IN 
                     SUBSCHEMA COMPILATION. 
          GFK     83/09/13   CBPASS3
  
 *L628*    ************************************************ 
 DL3A146  PROBLEM  - WHEN LEVEL88 ITEMS ARE DEFINED WITHIN A SUB-SCHEMA 
                     THAT ALSO USES CONCATENATED KEY, THE ERROR MESSAGE 
                     "KEY NOT FOUND" MAY BE GIVEN ERRONEOUSLY.
                     THIS HAPPENS BECAUSE THE PROCEDURE FOR PROCESSING
                     CONCATENATED KEYS COUNTS LEVEL88 ENTRIES AS ITEMS, 
                     BUT THEY ARE NOT INCLUDED IN TOTAL NUMBER OF ITEMS 
                     (SBRECNBRITMS).
          SOLUTION - SKIP ALL LEVEL88 ITEMS.
          KIM    07/05/84   CBBLDDC 
  
 DL3A155  PROBLEM  - THE SCHEMA COMPILER IS UNABLE TO DETECT
                     INCONSISTENCY BETWEEN ITEM NAMES IN THE RECORD 
                     DISCRIPTION ENTRY AND THE DATA CONTROL ENTRY.
                     FOR EXAMPLE, THE ITEM -XX- IN THE RECORD DISCRIP-
                     TION WAS SPELLED AS -X- IN THE DATA CONTROL ENTRY. 
                     THIS DID NOT RESULT ANY ERRORS IN SCHEMA AND SUB-
                     SCHEMA COMPILATIONS, BUT DDL ASSUMES -X- TO BE A 
                     NON-EMBEDDED KEY.  THEREFORE, AT EXECUTION TIME, 
                     THE KA FIELD IN THE FIT FOR THIS AREA WAS SET TO 
                     A WRONG ADDRESS AND CAUSED A MODE ERROR. 
          SOLUTION - SINCE CDCS DOES NOT SUPPORT NON-EMBEDDED KEY, DDL
                     WILL ISSUE ERROR 212, DATANAME FOR KEY NOT DEFINED 
                     IN RECORD WITHIN THIS AREA, FOR UNDEFINED ITEM NAME
          KIM    84/06/25    DCSYNG, DCSYNX 
  
 DL3A158  PROBLEM  - SYNGEN LISTS PRINT ON EVERY SECOND PAGE. 
                     THE CODE FOR DL3A149 DID NOT PROVIDE FOR THE HEADER
                     LINES WHEN SETTING UP THE PAGE SIZE FOR SYNGEN 
                     LISTS. 
          SOLUTION - INITIALIZE THE LINE COUNT FOR THE PAGE TO FOUR TO
                     PROVIDE FOR THE HEADER LINES THAT ARE ALREADY
                     SET UP.
          RLM     84/02/15   SYNGEN 
  
 DL3A160  PROBLEM  - THE DDL COBOL SUBSCEMA COMPILER ABORTS DURING
                     PASS TWO WITH THE DIAGNOSTIC 
                       "INSUFFICIENT FIELD LENGTH    DDL ABORTED".
                     THE PROBLEM OCCURS BECAUSE CBMAIN (DL30400) SETS 
                     THE MAXIMUM FIELD LENGTH EQUAL TO THE CURRENT
                     FIELD LENGTH.
          SOLUTION - REMOVE THE STATEMENT THAT SETS THE VARIABLE
                     "MAXFL"
          RLM     84/07/31   CBMAIN 
  
 DL30046  PROBLEM  - THE SCHEMA COMPILER ALLOWS THE DEFINITION OF 
                     OVERLAPPING CONCATENATED KEYS, BUT THE SUBSCHEMA 
                     COMPILER DOES NOT. 
                     WHEN AN OVERLAPPING CONCATENATED KEY IS DEFINED IN 
                     THE SUBSCHEMA ERROR 313 RESULTS (ITEM XXX DOES NOT 
                     QUALIFY AS A VALID CONCATENATED KEY) BECAUSE THE 
                     CONTIGUITY CHECK FAILS.
                     THE RECORD MAPER IS NOT SETTING RKW AND RKP
                     PROPERLY FOR MAJOR KEYS,  WHEN THE KEY IS IN A 
                     DIFFERENT LOCATION IN THE SUBSCHEMA THAN IN THE
                     SCHEMA.
          SOLUTION - MODIFY THE CONTIGUITY CHECK SO THAT OVERLAPPING
                     CONCATENATED KEYS ARE ACCEPTED.
                     MODIFY THE RECORD MAPPER SO THAT IT GENERATES CODE 
                     TO SET RKW AND RKP PROPERLY FOR ALL MAJOR KEYS.
          EPJ     84/02/18   CBBLDDC, CBSSITA, COMAPKEY 
  
 DL30047  PROBLEM  - WHEN A COBOL SUBSCHEMA IS DEFINED SUCH THAT THE
                     SUM OF THE NUMBER OF REALMS AND THE NUMBER OF
                     RELATIONS IS GREATER THAN 130, THEN THE SUBSCHEMA
                     WILL NOT COMPILE CORRECTLY.
                     SOMETIMES IT WILL RESULT IN A MODE ERROR DURING THE
                     SUBSCHEMA COMPILATION. 
                     SOMETIMES DBMSTRD WILL DIAGNOSE AN ERROR IN THE
                     SUBSCHEMA DIRECTORY. 
          SOLUTION - CONVERT THE REALM LIST TABLE TO A VARIABLE LENGTH
                     TABLE. 
                     INITIALLY THE SIZE WILL PERMIT 30 AREAS/RELATIONS. 
                     WHEN FILLED, IT IS INCREASED BY 10 AT A TIME.
                     MEMORY MANAGEMENT IS ALSO MODIFIED TO REDUCE THE 
                     FIELD LENGTH IF IT IS EXCESSIVELY LARGE. 
          RLM     84/01/27   CBMAIN,  CBPASS1,
                             CBCKBUF, CBPASS3 
  
 DL30051 PROBLEM  - THE QU *DISPLAY* DIRECTIVE DOES NOT WORK PROPERLY 
                    FOR VARIABLE LENGTH PORTION OF VARIABLE LENGTH FILE.
                    DISPLAY OF GROUP NAME PRODUCES GOOD DATA.  DISPLAY
                    OF ELEMENTARY NAME IN GROUP PRODUCES INCORRECT
                    DATA, BECAUSE THE SBIMTDOMORD, SBITMBWP AND 
                    SBITMBBP WERE CALCULATED INCORRECTLY. 
  
         SOLUTION - THE SBITMDOMORD OF ITEMS, WHICH SUBORDINATE TO
                    REPEATING GROUP ITEM, IS SET TO ORDINAL NUMBER OF 
                    DOMINANT ITEM.  THE SBITMBWP AND SBITMBBP ARE 
                    SET RELATIVELY TO DOMINANT ITEM.
         KIM   8/07/84    CBPASS1, CBSIZE 
  
 *L642*    ************************************************ 
 DL3A162  PROBLEM  - ERROR MODE 1 IN CBSTBCK DURING A COBOL SUBSCHEMA 
                     COMPILATION. 
                     IF NAME-A REDEFINES NAME-B AND THE NAME NAME-A 
                     IS USED WITHIN A DIFFERENT RECORD DEFINITION IN
                     THE SAME SUBSCHEMA, THERE IS A CHANCE OF AN
                     "ADDRESS OUT OF RANGE" OCCURING DURING PASS 2 OF 
                     SUBSCHEMA COMPILATION. 
                     CHANCES OF THIS OCCURING ARE MUCH GREATER SINCE THE
                     PASS 2 FIELD LENGTH HAS BEEN REDUCED BY DL30047. 
                     CHANCES ARE ALSO INCREASED AS THE SECOND USE OF THE
                     NAME IS FURTHER REMOVED FROM THE BEGINNING OF THE
                     SUBSCHEMA. 
          SOLUTION - INITIALIZE SBITMSCPTR TO A ZERO VALUE FOR REDEFINE 
                     ITEM ENTRIES AS WELL AS ALL OTHERS.
          RLM     84/10/24   CBCKREC
  
 DL30055  PROBLEM  - DDL ABORTED WITH RM ERROR 120 ON LFN ZZZZZCC WHILE 
                     ATTEMPTING TO BUILD THE HASH INDEX TABLE.  THIS
                     OCCURS BECAUSE DDL LOSES TRACK OF ITS POINTERS 
                     WHILE SEARCHING THROUGH THE OVERFLOW CHAIN FOR 
                     SYNONYM ENTRIES. 
          SOLUTION - INSERT A NEW ITEM NAMED SAVEOFLLOC TO STORE THE
                     CURRENT LOCATION OF INTEREST IN THE OVERFLOW CHAIN.
          KIM    84/10/03    DLHASH 
  
 *L650*    ************************************************ 
 DL30059  PROBLEM  - DDL3 CANNOT FIND SOME AREAS OF A LARGE (112 AREA)
                     SCHEMA WHEN COMPILING THE SUBSCHEMA, BECAUSE SOME
                     OF THESE AREAS YIELD THE SAME HASH-ID, AND DLHASH
                     DOES NOT HANDLE THE COLLISION PROPERLY.
          SOLUTION - THE PROCESSING OF COLLISION BY DLHASH IS REWRITTEN 
                     TO HANDLE SAMENAMES AND SYNONYMS.
          NOTE     - DL30059 DEPENDS ON DL30055.
  
          KIM     85/08/06   DLHASH 
  
 *L670*    ************************************************ 
 DL3A165  PROBLEM  -  RETRANSMITTED CODE AT 18I1 THAT WAS ORIGINALLY
                      TRANSMITTED AT 16R2.
          SOLUTION -  THIS PSR WILL PURGE THE CODE THAT WAS TRANSMITTED 
                      AT 16R2 SO THAT INTEGRATION'S PL MATCHES DDL'S. 
  
          PJR      86/01/09 
  
 DL3A167  PROBLEM  - WHEN COMPILING A SUBSCHEMA, IF A RELATION IS 
                     REFERENCED THAT IS NOT DEFINED IN THE SCHEMA,
                     DDL TERMINATES WITH AN ADDRESS OUT OF RANGE, 
                     AFTER GIVING THE DIAGNOSTIC 403. 
          SOLUTION - AFTER ISSUING THE ERROR 403, DDL SHOULD IGNORE 
                     THE REST OF THE CURRENT STATEMENT AND RESUME 
                     THE COMPILATION AT NEXT ONE. 
          KIM     86/03/18   CBRSYN 
  
 DL3A168  PROBLEM  - DDLF SUBSCHEMA COMPILATION FAILED WITH ERROR 302 --
                     SUBSCHEMA ITEM DOES NOT APPEAR IN SCHEMA--BUT THAT 
                     ITEM DID EXIST IN THE SCHEMA.
                     CURRENT NEW ENTRY WAS FOUND TO BE A SYNONYM OF AN
                     EXISTING ENTRY.  ALL SAMENAME ENTRIES WERE STORED
                     AND LINKED TO THE OVERFLOW AREA, AND OTHERS WERE 
                     REHASHED.
                     THE REHASHING PROCESS DID NOT WORK CORRECTLY WHEN
                     THE HASHED LOCATION FOR THE REHASHED ENTRY WAS 
                     OCCUPIED AND AN OPEN SLOT WAS NOT FOUND IN THE 
                     PRIME AREA.
  
          SOLUTION - INTRODUCE A NEW PROCEDURE CALLED -REHASHOFLCUR-
                     TO HANDLE THE REHASHING PROCESS WHEN THE CURRENT 
                     PRIME ENTRY HAS TO GO TO OVERFLOW AREA.
  
          NOTE     - THIS PSR IS DEPENDED ON DL30059. 
  
          KIM     86/05/23   DLHASH 
  
 DL30058  PROBLEM  - 1. ERROR 176 "LEVEL NUMBER OF DATA-NAME IS NOT 
                     IDENTICAL TO DATA-NAME-2". 
                     WHILE SEACHING FOR DATA-NAME-2, DDL LOCATES
                     ANOTHER NAME THAT IS THE SAME AS DATA-NAME-2 
                     EXCEPT THAT IT IS SHORTER.  IF THAT NAME HAS A 
                     DIFFERENT LEVEL, THEN ERROR 176 IS ISSUED. 
  
                     2. ERROR 178 IS ISSUED ERRONEOUSLY.
                     DDL FAILS IN COMPUTING THE ITEM SIZE WHEN AN ITEM
                     REDEFINES A GROUP ITEM, OR A REPEATING GROUP ITEM
                     REDEFINES A GROUP ITEM, OR THERE IS A REDEFINITION 
                     OF A LAST ITEM OF A RECORD.
  
                     3. CRM 167 DURING WRITE OR REWRITE ON LAST REALM 
                     IN SUBSCHEMA WITH REDEFINES. 
                     THE RECORD LENGTH IS CALCULATED INCORRECTLY. 
  
          SOLUTION - 1. SKIP ALL ITEM NAMES THAT ARE NOT THE SAME 
                     LENGTH AS DATA-NAME-2. 
  
                     2.  DO NOT ADD THE SIZE OF THE REDEFINE ITEM TO
                     THE ACCUMULATED SIZE OF THE CURRENT LEVEL AND OF 
                     THE CURRENT DOMINANT LEVEL, AND REINITIALIZE THE 
                     REDEFINE CELLS AFTER PROCESSING EACH RECORD. 
  
                     3.  SET THE RECORD LENGTH TO THE ACCUMULATED SIZE
                     OF THE HIGHEST LEVEL ITEM, WHICH IS A NON-REDEFINED
                     ITEM AND HAS DOMINANT IS A RECORD ENTRY. 
  
          NOTE     - THIS PSR IS RETRANSMITTED TO INCLUDE PROBLEMS
                     REPORTED BY DL30063, CD20295 AND CD20298 PSR'S.
  
          KIM     85/10/31   CBPASS1,CBSIZE 
  
 DL30062  PROBLEM  - CHANGES MADE IN ONE REALM IN THE SCHEMA CAUSE
                     CHECKSUMS TO BE DIFFERENT IN OTHER UNTOUCHED REALMS. 
                     USUALLY THESE REALMS ARE AFTER THE CHANGED REALM AND 
                     HAVE CONCATENATED KEY. 
                     BEFORE CALCULATING THE CHECKSUMS OF DATA CONTROL 
                     ENTRIES, DDL DOES NOT ERASE COMPLETELY THE WORD
                     ADDRESS OF DATA-NAMES THAT MAKE UP THE CONCATENATED
                     KEY. 
          SOLUTION - MODIFY -DCSYNX- TO CLEAR ALL WORD ADDRESS OF DATA- 
                     NAMES MAKING UP A CONCATENATED KEY.
          NOTE     - THESE FOLLOWING CODES WILL CHANGE THE METHOD OF
                     CALCULATING THE CHECKSUM FOR REALMS THAT HAVE
                     CONCATENATED KEY.  THEREFORE, AFTER THE FIRST
                     SCHEMA COMPILATION, ALL SUBSCHEMAS THAT HAVE REALMS
                     CONTAINING CONCATENATED KEY NEED TO BE RECOMPILED. 
                     THE CHECKSUMS IN THE SCHEMA AND SUBSCHEMAS WILL
                     REMAIN UNCHANGED, UNLESS SOME CHANGES ARE MADE ON
                     THE REALM. 
          KIM     85/10/14   DCSYNX 
  
 DL30065  PROBLEM  - CRM ERROR 506 WAS RETURNED WHEN A USER PROGRAM 
                     TRIED TO READ VIA AN ALTERNATE KEY WHICH DEFINED 
                     AS A REPEATING GROUP.
                     THE RECORD MAPPER TREATS THE REPEATING GROUP KEY 
                     THE SAME AS THE CONCATENATED KEY WHEN IT CALCULATES
                     RKW AND RKP OF THE ALTERNATE KEY.  SINCE IT DOES 
                     CALCULATE THE CORRECT RKW AND RKP, THE VALUES
                     STORED IN THE FIT WILL BE WRONG. 
          SOLUTION - MODIFY THE RECORD MAPPER SO THAT IT GENERATES CODE 
                     TO SET RKW AND RKP PROPERLY FOR ALL ALTERNATE KEYS 
                     ON REPEATING GROUPS. 
  
          KIM     86/01/07   COMAPKEY 
  
 *L688*    ************************************************ 
 DL30069  PROBLEM  - WHEN COMPILING A SCHEMA WITH MORE THAN 167 AREAS,
                     DDL3 ABORTED WITH -CM OUT OF RANGE-. 
                     A SCOPE MEMORY REQUEST WAS NOT MADE TO OBTAIN MORE 
                     MEMORY WHEN THE DATA WAS TO BE WRITTEN AT LWA OF 
                     THE SYMBOL TABLE.
          SOLUTION - A REQUEST FOR MORE MEMORY WILL BE MADE IF THE DATA 
                     IS TO BE WRITTEN AT LOCATION BEYOND THE LWA-7 OF 
                     THE SYMBOL TABLE.
          KIM     86/06/04   SCHEMIO
  
 DL30071  PROBLEM  - DDLF SUBSCHEMA COMPILATION FAILED WITH ERROR 302 --
                     SUBSCHEMA ITEM DOES NOT APPEAR IN SCHEMA--BUT THAT 
                     ITEM DID EXIST IN THE SCHEMA.
                     CURRENT NEW ENTRY WAS FOUND TO BE A SYNONYM OF AN
                     EXISTING ENTRY.  ALL SAMENAME ENTRIES WERE STORED
                     AND LINKED TO THE OVERFLOW AREA, AND OTHERS WERE 
                     REHASHED.
                     THE REHASHING PROCESS DID NOT WORK CORRECTLY WHEN
                     THE HASHED LOCATION FOR THE REHASHED ENTRY WAS 
                     OCCUPIED AND AN OPEN SLOT WAS NOT FOUND IN THE 
                     PRIME AREA.
  
          SOLUTION - WHEN NO AVAILABLE LOCATION IS FOUND WITHIN 255 
                     WORDS, THE PRIME CHAIN WILL HAVE TO CONTINUE IN
                     OVERFLOW AREA.  AFTER BUILDING THE OVERFLOW
                     ENTRIES FOR THE CURRENT PRIME AND REHASHED ITEM, 
                     IF THE SAVESYN FLAG OF THE REHASHED ITEM IS SET
                     THEN COPY THE REST OF THE OVERFLOW CHAIN, WHICH
                     IS POINTED TO BY THE SAVEWA OF THE REHASHED ITEM,
                     TO THE NEW LOCATION AFTER THE REHASHED ENTRY IN
                     THE OVERFLOW AREA. 
  
          NOTE     - A SIMILAR PROBLEM WAS REPORTED IN DL3A168. 
                     THIS PSR IS DEPENDED ON DL30059 AND DL3A168. 
  
          KIM     86/08/28   DLHASH 
  
 *L716*    ************************************************ 
 DL3A169  PROBLEM  - THERE IS AN ERROR IN GENERATING READ MAPPING 
                     CAPSULES.
                     WHEN A 'BEFORE GET' ITEM-LEVEL DATABASE PROCEDURE
                     IS SPECIFIED, THE STORE REGISTER INSTRUCTIONS ARE
                     NOT GENERATED FOR THE ITEM IMMEDIATELY PRECEDING 
                     THE ITEM OF THE DATABASE PROCEDURE.
                     THIS CAUSES A PROBLEM WHEN THE PRECEDING ITEM
                     IS WORD ALIGNED AND DOES NOT REQUIRE A SPECIAL 
                     DATA TRANSLATION.
          SOLUTION - GENERATE THE STORE REGISTER INSTRUCTIONS.
          RLM     87/11/23   COMMAPRD 
  
 DL30075  PROBLEM  - DDL ENCOUNTERS ERRORS WHILE WRITING ON THE HASH
                     OVERFLOW FILE. 
          SOLUTION - REVISE THE HASHING ROUTINE TO AVOID USING THE
                     OVERFLOW FILE WITH SUCH FREQUENCY. 
  
          NOTE -     EVEN THOUGH ALL OF THE CODE IS ON THE DDL PL,
                     IT IS NECESSARY TO REBUILD DBMSTRD.
                     DBMSTRD USES DE$NMSC AND DE$HASH TO ACCESS 
                     FILE NAMES FROM THE SCHEMA DIRECTORY.
                     THESE ARE LOADED INTO THE DBMSTRD BINARY FROM
                     DMSLIB WHERE THEY ARE LEFT DURING A DDL BUILD. 
  
          NOTE 2 -   THIS CODE WILL IDENTIFY A SCHEMA DIRECTORY THAT
                     WAS COMPILED USING THE OLD HASH CODE AND WILL
                     ACCESS IT USING THE OLD HASH.
                     THIS MAKES IT UNNECESSARY TO RECOMPILE EXISTING
                     SCHEMA DIRECTORIES.
  
          RLM     87/07/06   SCCWDECLS, DLHASH, 
                             DA$NMSC, DDL3HASH
  
 DL30076  PROBLEM  - A MEMORY OVERFLOW IS NOT HANDLED CORRECTLY.
          SOLUTION - REQUEST MORE MEMORY IF POSSIBLE. 
          RLM     88/02/22   CBINDEX
  
 *L739*    ************************************************ 
 *L780*    ************************************************ 
 DL30077  PROBLEM  - "****ILL-FORMATTED LIBRARY" ERROR IS ERRONEOUSLY 
                     ISSUED WHEN THE SUBSCHEMA LIBRARY IS LONGER THAN 
                     4096 WORDS AND HAPPENS TO END ON A PRU BOUNDARY. 
          SOLUTION - READ THE ENTIRE FINAL PRU WHEN SEARCHING FOR THE 
                     END OF THE SUBSCHEMA LIBRARY.
          RLM     89/12/27   COMSSLIB, QDSSLIB
  
 PSRLEVEL MODIFY PSR LEVEL IN DDL3
          BAO  92/10/02  CTLIO
 *L797*    ************************************************ 
 *L803*    ************************************************ 
 *L826*    ************************************************ 
 *L840*    ************************************************ 
 *L847*    ************************************************ 
 *L851*    ************************************************ 
 *L859*    ************************************************ 
 *L871*    ************************************************ 
L406     ***
  
  
